﻿using System;

using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using System.Runtime.InteropServices;
using _Native;

namespace SystemService_CreateFullScreenApp
{
    public partial class Form1 : Form
    {
        public const string title = "FullScreen App Example";
        private FormBorderStyle formBorderStyle = FormBorderStyle.FixedSingle;
        private bool isFullScreen = false;
        private bool isAllKeys = false;

        public Form1()
        {
            InitializeComponent();
            this.Text = title;
            if (Utils.IsWinCE)
                this.Menu = null;

            this.MinimizeBox = false;
            this.MaximizeBox = false;
            this.formBorderStyle = this.FormBorderStyle;
        }

        private void Form1_Closing(object sender, CancelEventArgs e)
        {
            if (FullScreen)
                FullScreen = false;

            if (DontAllowOSToInterceptButtonPresses)
                DontAllowOSToInterceptButtonPresses = false;
        }

        public bool FullScreen
        {
            get
            {
                return isFullScreen;
            }
            set
            {
                if (Utils.IsWinCE)
                {
                    this.ControlBox = (value == true ? false : true);
                    this.WindowState = FormWindowState.Normal;
                    this.FormBorderStyle = (value == true ? FormBorderStyle.None : formBorderStyle);
                    this.Size = new Size(240, 320);
                    int posY = (value ? 320 : 294);
                    Utils.MoveWindow(Utils.FindWindow("HHTaskBar", null), 0, posY, 320, 26, true);
                }
                else
                {
                    this.Menu = (value == true ? null : mainMenu1);
                    this.WindowState = (value == true ? FormWindowState.Maximized : FormWindowState.Normal);
                }

                isFullScreen = value;
            }
        }

        public bool DontAllowOSToInterceptButtonPresses
        {
            get
            {
                return isAllKeys;
            }
            set
            {
                Utils.AllKeys(value);
                isAllKeys = value;
            }
        }

        private void chkFullScreen_CheckStateChanged(object sender, EventArgs e)
        {
            // turned on or off the full screen.
            this.FullScreen = chkFullScreen.Checked;
        }

        private void chkAllKeys_CheckStateChanged(object sender, EventArgs e)
        {
            // set AllKeys to true or false
            this.DontAllowOSToInterceptButtonPresses = chkAllKeys.Checked;
            // Please refer to the link below for more information.
            // https://msdn.microsoft.com/en-us/library/ee501942(v=winembedded.60).aspx
        }
    }
}