// BarcodeDlg.cpp : implementation file
//

#include "stdafx.h"
#include "Barcode.h"
#include "BarcodeDlg.h"
#include "BarcodeDef.h"
#ifdef _DEBUG
#define new DEBUG_NEW
#endif


// CBarcodeDlg dialog

CBarcodeDlg::CBarcodeDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CBarcodeDlg::IDD, pParent)
{
	m_nldx =0;
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CBarcodeDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	DDX_Control(pDX, IDC_LIST_BARCODE_DATA,m_listBarcodeData);
	DDX_Control(pDX, btnStart,m_btnStart);
	DDX_Control(pDX, btnStop,m_btnStop);
	DDX_Control(pDX, btnClear,m_btnClear);
	DDX_Control(pDX, IDC_COMBO1, cbxLightMode);
	DDX_Control(pDX, IDC_COMBO2, cbxLeaveLightOn);
	DDX_Control(pDX, chkRaw, m_chkRaw);
	DDX_Control(pDX, chkSound, m_chkSound);
	DDX_Control(pDX, chkVibrator, m_chkVibrator);
}

BEGIN_MESSAGE_MAP(CBarcodeDlg, CDialog)
#if defined(_DEVICE_RESOLUTION_AWARE) && !defined(WIN32_PLATFORM_WFSP)
	ON_WM_SIZE()
#endif
	ON_BN_CLICKED(btnStart, &CBarcodeDlg::OnBnClickedbtnstart)
	ON_BN_CLICKED(btnStop, &CBarcodeDlg::OnBnClickedbtnstop)
	ON_BN_CLICKED(btnClear, &CBarcodeDlg::OnBnClickedbtnclear)
	ON_CBN_SELCHANGE(IDC_COMBO1, &CBarcodeDlg::OnCbnSelchangeLightMode)
	ON_CBN_SELCHANGE(IDC_COMBO2, &CBarcodeDlg::OnCbnSelchangeLeaveLightOn)
	ON_WM_TIMER()
	ON_WM_COPYDATA()
	//}}AFX_MSG_MAP
	

	
END_MESSAGE_MAP()


// CBarcodeDlg message handlers

BOOL CBarcodeDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	BeginWaitCursor();
	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon

	CenterWindow(GetDesktopWindow());
	// TODO: Add extra initialization here
	
	 // Check what type of scanner.
	HW_OPTIONS hwOptions;
	GetHardwareOptions(&hwOptions);
	if(hwOptions.BarcodeType==HW_TYPE_BARCODE_NONE){
		
		return FALSE;
	}
	if(hwOptions.BarcodeType==HW_TYPE_BARCODE_2DSWD_H || hwOptions.BarcodeType==HW_TYPE_BARCODE_2DSWD_M)
		is2DScanner = TRUE;
	else 
		is2DScanner = FALSE;
	
	if(is2DScanner){
		cbxLeaveLightOn.AddString(_T("Be flashed on and off"));
		cbxLeaveLightOn.AddString(_T("Always on"));
		BOOL *alwaysOn = FALSE;
		BarcodeGetLeaveLightsOn(alwaysOn);
		cbxLeaveLightOn.SetCurSel(alwaysOn?1:0);

		
		cbxLightMode.AddString(_T("Neither aimers nor illumination"));
        cbxLightMode.AddString(_T("Illumination only"));
        cbxLightMode.AddString(_T("Aimers only"));
        cbxLightMode.AddString(_T("Both aimers and illumination"));
        cbxLightMode.SetCurSel(3);
	
	}else{
		cbxLeaveLightOn.AddString(_T("LeaveLightOn not supported"));
        cbxLeaveLightOn.SetCurSel(0);
        cbxLightMode.AddString(_T("LightMode not supported"));
        cbxLightMode.SetCurSel(0);

		m_chkRaw.EnableWindow(FALSE);
		cbxLeaveLightOn.EnableWindow(FALSE);
		cbxLightMode.EnableWindow(FALSE);	
	}

	// create barcode object
	BARCODE_RESULT result = BarcodeOpen();
	if(result != BARCODE_RESULT_SUCCESS){
		if(result == BARCODE_RESULT_CAM_SELECTED)
			AfxMessageBox(_T("CAM already turned on!!\r\nTry again after turn off CAM"));
		else if(result == BARCODE_RESULT_ALREADY_BARCODE_SELECTED)
			AfxMessageBox(_T("Other barcode application already running!!"));
		else if(result == BARCODE_RESULT_ALREADY_OPENED)
			AfxMessageBox(_T("Already opened"));
		else
			AfxMessageBox(_T("Open failed"));

		AfxGetMainWnd()->PostMessage(WM_QUIT);
	
		
	}
	// create system service object
	if (AllocSysSvc() != SYSSVC_RESULT_SUCCESS)
	{
		AfxMessageBox(_T("AllocSysSvc Fail"));
	}

	 // When decoding is successful, register a callback function to be executed.
	BarcodeSetHwnd(this->m_hWnd);
	UpdateData(FALSE);

	m_listBarcodeData.InsertColumn(0, _T("Value"), LVCFMT_LEFT, 130);
	m_listBarcodeData.InsertColumn(1, _T("Name"), LVCFMT_LEFT, 80);
	//m_listBarcodeData.InsertColumn(2, _T("Id"), LVCFMT_LEFT, 50);

	EndWaitCursor();
	return TRUE;  // return TRUE  unless you set the focus to a control
}

BOOL CBarcodeDlg::OnCopyData(CWnd * pWnd, COPYDATASTRUCT* pCopyDataStruct){
	// TODO: Add your message handler code here and/or call default
	// TODO: Add your message handler code here and/or call default
	TCHAR szValue[2048] = _T("");
	TCHAR szBarValue[2048] = _T("");

	BYTE byteValue[2048];
	CString str;
	CString temp;
	WORD lenOfValue = 0;
	TCHAR szBarTypeName[512] = _T("");
	TCHAR szBarTypeId[4] = _T("");
	
	switch(pCopyDataStruct->dwData) 
	{
    case WM_BARCODE_ONSCANED:
		UpdateData();
		
		if(m_chkRaw.GetCheck())
		{
			BARCODE_RESULT result = BarcodeGetScannedRawData(byteValue, &lenOfValue, szBarTypeName, szBarTypeId);
			
			for(int i=0; i<lenOfValue; i++)
			{
				str.Format(_T("%02X "), byteValue[i]);
				temp.Append(str);
			}

			wsprintf(szBarValue,_T("%s"),temp);
		}
		else
		{
		BarcodeGetScannedData(szBarValue, szBarTypeName, szBarTypeId);
		}

		m_listBarcodeData.InsertItem(m_nldx, szBarValue);
		m_listBarcodeData.SetItemText(m_nldx,1,szBarTypeName);
		m_listBarcodeData.SetItemText(m_nldx,2,szBarTypeId);
		m_nldx++;

		if(m_chkSound.GetCheck())
		PlaySound(_T("\\Windows\\success.wav"), NULL, SND_ASYNC);

		if(m_chkVibrator.GetCheck())
		{
			this->SetTimer(1,250,NULL);
		}
		

		m_listBarcodeData.EnsureVisible(m_listBarcodeData.GetItemCount() -1,TRUE);
		m_listBarcodeData.SetFocus();

		
		this->m_btnStart.EnableWindow(TRUE);
        break;

	default:
		break;
    }
	return CDialog::OnCopyData(pWnd, pCopyDataStruct);



}

BOOL CBarcodeDlg::DestroyWindow() 
{
	// TODO: Add your specialized code here and/or call the base class

	 // destruction of the barcode object
	if (BarcodeClose() != BARCODE_RESULT_SUCCESS)
		AfxMessageBox(_T(" BarcodeClose Fail "));
	
	return CDialog::DestroyWindow();
}


BOOL CBarcodeDlg::PreTranslateMessage(MSG* pMsg) 
{
	// TODO: Add your specialized code here and/or call the base class
	
	TCHAR	BarVal[MAX_STR] = _T("");
	TCHAR	BarType[MAX_STR] = _T("");
	CString	sStart;
	
	switch(pMsg->message)
	{
	case WM_KEYDOWN:
		switch(pMsg->wParam)
		{
		case VK_F1:
		case VK_F2:
		case VK_F7:
		case VK_F8:
			if(BarcodeIsOpened())
			{
				m_btnStart.EnableWindow(FALSE);
				this->OnBnClickedbtnstart();
			}
			break;
		default:
			break;
		}
		break;
		case WM_KEYUP:
			switch(pMsg->wParam)
			{
			case VK_F1:
			case VK_F2:
			case VK_F7:
			case VK_F8:
				if(BarcodeIsOpened()){
					this->OnBnClickedbtnstop();
					
				}
				break;
			default:
				break;
			}
			break;

	}

	return CDialog::PreTranslateMessage(pMsg);
}
#if defined(_DEVICE_RESOLUTION_AWARE) && !defined(WIN32_PLATFORM_WFSP)
void CBarcodeDlg::OnSize(UINT /*nType*/, int /*cx*/, int /*cy*/)
{
	if (AfxIsDRAEnabled())
	{
		DRA::RelayoutDialog(
			AfxGetResourceHandle(), 
			this->m_hWnd, 
			DRA::GetDisplayMode() != DRA::Portrait ? 
			MAKEINTRESOURCE(IDD_BARCODE_DIALOG_WIDE) : 
			MAKEINTRESOURCE(IDD_BARCODE_DIALOG));
	}
}
#endif


void CBarcodeDlg::OnBnClickedbtnstart()
{
	// TODO: ⿡ Ʈ ˸ ó ڵ带 ߰մϴ.
	BARCODE_RESULT res;
	m_btnStart.EnableWindow(FALSE);

	if(BarcodeIsOpened()){
		
		if(m_chkRaw.GetCheck()){
			res = BarcodeStartScanRawData();
		}else{
		res = BarcodeStart();
		}
		if(res != BARCODE_RESULT_SUCCESS){
		return;
		}
		
	}else{
		if(m_chkRaw.GetCheck()){
			res = BarcodeStopScanRawData();
		}else{
		res = BarcodeStop();
		}
		if(res != BARCODE_RESULT_SUCCESS)
		{
			m_btnStart.EnableWindow(TRUE);
			return;
		}
	}
}

void CBarcodeDlg::OnBnClickedbtnstop()
{
	BARCODE_RESULT res;
	// TODO: ⿡ Ʈ ˸ ó ڵ带 ߰մϴ.
	if(BarcodeIsOpened()){
		if(m_chkRaw.GetCheck()){
			res= BarcodeStopScanRawData();
		}else res=BarcodeStop();
		m_btnStart.EnableWindow(TRUE);
	}
}

void CBarcodeDlg::OnBnClickedbtnclear()
{
	// TODO: ⿡ Ʈ ˸ ó ڵ带 ߰մϴ.
	m_listBarcodeData.SetItemCount(0);
	m_listBarcodeData.DeleteAllItems();
	m_nldx =0;
}

void CBarcodeDlg::OnCbnSelchangeLightMode()
{
	// TODO: ⿡ Ʈ ˸ ó ڵ带 ߰մϴ.
	if(BarcodeIsOpened()){
		// 0 : Neither aimers nor illumination
		// 1 : Illumination only
        // 2 : Aimers only
        // 3 : Both aimers and illumination		

		BarcodeSetScanningLightsMode(cbxLightMode.GetCurSel());
	}
}

void CBarcodeDlg::OnCbnSelchangeLeaveLightOn()
{
	// TODO: ⿡ Ʈ ˸ ó ڵ带 ߰մϴ.
	if(BarcodeIsOpened()){
		// true : Always on
        // false : Be flashed on and off

		BarcodeSetLeaveLightsOn(cbxLeaveLightOn.GetCurSel());
	}
}

void CBarcodeDlg::OnTimer(UINT nIDEvent){
	switch (nIDEvent){
		case 1:
			SetVibratorEnable(TRUE);
			break;
	}
	this->KillTimer(1);
	Sleep(250);
	SetVibratorEnable(FALSE);
	CDialog::OnTimer(nIDEvent);
}