// Lock.cpp :  Դϴ.
//

#include "stdafx.h"
#include "RFID.h"
#include "Lock.h"
#include "RFIDDef.h"
extern CString SelectedTagValue;
CString targetTagLock;
// CLock ȭ Դϴ.

IMPLEMENT_DYNAMIC(CLock, CDialog)

CLock::CLock(CWnd* pParent /*=NULL*/)
	: CDialog(CLock::IDD, pParent)
{

}

CLock::~CLock()
{
}

void CLock::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	DDX_Control(pDX, IDC_COMBO1, m_cbxAction);
	DDX_Control(pDX, IDC_EDIT3, m_nAccessPassword);
	DDX_Control(pDX, IDC_EDIT2, m_nEditTarget);
	DDX_Control(pDX, IDC_ACTION, m_btnAction);
	DDX_Control(pDX, IDC_KILL, m_chkKillPassword);
	DDX_Control(pDX, IDC_ACCESS, m_chkAccessPassword);
	DDX_Control(pDX, IDC_EPC, m_chkEPC);
	DDX_Control(pDX, IDC_TID, m_chkTID);
	DDX_Control(pDX, IDC_USER, m_chkUSER);
	DDX_Control(pDX, IDC_LIST1, m_listMessage);
}


BEGIN_MESSAGE_MAP(CLock, CDialog)
	ON_BN_CLICKED(IDC_ACTION, &CLock::OnBnClickedAction)
END_MESSAGE_MAP()


// CLock ޽ óԴϴ.

BOOL CLock::OnInitDialog(){
	CDialog::OnInitDialog();
	m_idx =0;
	if(RfidIsOpen() == FALSE) 
	{
		RfidPowerOff();
		AfxMessageBox(_T("open failed!"));
	}

	
	RETAILMSG(1, (TEXT("[APP, GetSelectedTag] ->> GetSelectedTag \t[ %s ] \r\n"), SelectedTagValue));
	int maxTargetLength = MAX_MASK_BYTES*2;
	targetTagLock = SelectedTagValue;
	if(targetTagLock.GetLength() > maxTargetLength)
		targetTagLock.SetString(targetTagLock,maxTargetLength);

	m_nEditTarget.SetWindowTextW(targetTagLock);


	m_cbxAction.AddString(_T("Lock"));
	m_cbxAction.AddString(_T("UnLock"));
	m_cbxAction.AddString(_T("Permalock"));
	m_cbxAction.AddString(_T("Permaunlock"));
	m_cbxAction.SetCurSel(0);

	m_listMessage.InsertColumn(0, _T("Message"),0,200,-1);

	// If you want to operate synchronously, the operation time must be set to a value other than zero.
    // If set to 0, you may not be able to stop the operation.
	RfidSetOperationTime(3);
	return TRUE;
}
void CLock::OnBnClickedAction()
{
	// TODO: ⿡ Ʈ ˸ ó ڵ带 ߰մϴ.
	CString		sAccpwd;
	CString		sPattern;
	TCHAR		tszPattern[MAX_PATH] = _T(""),
				tszAccpwd[MAX_PATH] = _T("");


	RFIDMASK_PARAMS		LockMask;
	RFID_RESULT			result;
	RFIDLOCK_UNLOCK_FIELD		LockField;


	memset(&LockMask, 0x00, sizeof(RFIDMASK_PARAMS));
	memset(&LockField, 0x00, sizeof(RFIDLOCK_UNLOCK_FIELD));

	m_nAccessPassword.GetWindowTextW(sAccpwd);
	if(!sAccpwd.Compare(_T("")) ==0){
		// access password is a 4-byte data.
		if(sAccpwd.GetLength() !=8){
			AfxMessageBox(_T("Access password is 4 bytes"));
			m_nAccessPassword.GetFocus();
			return ;
		}
		wsprintf(tszAccpwd,_T("%s"), sAccpwd);
	}


	this->m_nEditTarget.GetWindowTextW(sPattern);
	
	if(!sPattern.Compare(_T("")) ==0){
		// To lock only tags that you selected on the previous screen
		LockMask.nOffSet = 4;	// nibble offset
		LockMask.MemBank = RFID_MEM_BANK_EPC;
		wsprintf(tszPattern,_T("%s"),sPattern);
		LockMask.szMaskPattern = tszPattern;
	}

	m_btnAction.EnableWindow(FALSE);

	if(this->m_chkAccessPassword.GetCheck()) LockField.bAccessPassword = TRUE;
	//else LockField.bAccessPassword = FALSE;
	
	if(this->m_chkEPC.GetCheck()) LockField.bEPC = TRUE;
	//else LockField.bEPC = FALSE;
	
	if(this->m_chkKillPassword.GetCheck()) LockField.bKillPassword = TRUE;
	//else LockField.bKillPassword = FALSE;
	
	if(this->m_chkTID.GetCheck()) LockField.bTID = TRUE;
	//else LockField.bTID = FALSE;
	
	if(this->m_chkUSER.GetCheck()) LockField.bUSER = TRUE;
	//else LockField.bUSER = FALSE;

	switch(this->m_cbxAction.GetCurSel()){
		case 0: // Change the tag to the password accessible state
			result = RfidLockField(TRUE,&LockField,FALSE,tszAccpwd,&LockMask);
			DisplayRfidResult(result);
		break;
		case 1:	// Change the tag to the accessible state
			result = RfidUnLockField(TRUE,&LockField, FALSE, tszAccpwd,&LockMask);
			DisplayRfidResult(result);
		break;
		case 2:	// Permanently change the tag to the alway not accessible state
			if(this->m_chkKillPassword.GetCheck()){
				result = RfidPermalock(TRUE, RFID_PERMALOCK_FIELD_KILL_PASSWORD, TRUE,FALSE,tszAccpwd,&LockMask);
				DisplayRfidResult(result);
			}

			if(this->m_chkAccessPassword.GetCheck()){
				result = RfidPermalock(TRUE,RFID_PERMALOCK_FIELD_ACCESS_PASSWORD,TRUE,FALSE,tszAccpwd,&LockMask);
				DisplayRfidResult(result);
			}

			if(this->m_chkEPC.GetCheck()){
				result = RfidPermalock(TRUE,RFID_PERMALOCK_FIELD_EPC,TRUE,FALSE,tszAccpwd,&LockMask);
				DisplayRfidResult(result);
			}

			if(this->m_chkTID.GetCheck()){
				result = RfidPermalock(TRUE,RFID_PERMALOCK_FIELD_TID,TRUE,FALSE,tszAccpwd,&LockMask);
				DisplayRfidResult(result);
			}

			if(this->m_chkUSER.GetCheck()){
				result = RfidPermalock(TRUE,RFID_PERMALOCK_FIELD_USER,TRUE,FALSE,tszAccpwd,&LockMask);
				DisplayRfidResult(result);
			}
		break;
		case 3:	// Permanently change the tag to the alway accessible state
			if(this->m_chkKillPassword.GetCheck()){
				result = RfidPermalock(TRUE, RFID_PERMALOCK_FIELD_KILL_PASSWORD, FALSE,FALSE,tszAccpwd,&LockMask);
				DisplayRfidResult(result);
			}

			if(this->m_chkAccessPassword.GetCheck()){
				result = RfidPermalock(TRUE,RFID_PERMALOCK_FIELD_ACCESS_PASSWORD,FALSE,FALSE,tszAccpwd,&LockMask);
				DisplayRfidResult(result);
			}

			if(this->m_chkEPC.GetCheck()){
				result = RfidPermalock(TRUE,RFID_PERMALOCK_FIELD_EPC,FALSE,FALSE,tszAccpwd,&LockMask);
				DisplayRfidResult(result);
			}

			if(this->m_chkTID.GetCheck()){
				result = RfidPermalock(TRUE,RFID_PERMALOCK_FIELD_TID,FALSE,FALSE,tszAccpwd,&LockMask);
				DisplayRfidResult(result);
			}

			if(this->m_chkUSER.GetCheck()){
				result = RfidPermalock(TRUE,RFID_PERMALOCK_FIELD_USER,FALSE,FALSE,tszAccpwd,&LockMask);
				DisplayRfidResult(result);
			}
		break;
	}
	
	// if you call a function asynchronously, function will return immediately.
    // You need to check the execution results are received by the callback function.
    // But If you call a function synchronously, the return value is a function execution results.
	if(result == RFID_RESULT_SUCCESS){
				PlaySound( _T("\\Windows\\success.wav"), NULL, SND_ASYNC|SND_NOSTOP);
				
			}else{
				PlaySound( _T("\\Windows\\Fail.wav"), NULL, SND_ASYNC|SND_NOSTOP);
			}
	m_btnAction.EnableWindow(TRUE);


}


void CLock::DisplayRfidResult(RFID_RESULT result){
	TCHAR szResult[MAX_PATH];
	memset(szResult, 0x00, sizeof(szResult));
	
	switch(result)
	{
	case RFID_RESULT_SUCCESS:
		wsprintf(szResult, _T(" Success "));
		break;
		
	case RFID_RESULT_OUTOFMEMORY:
		wsprintf(szResult, _T(" Out Of Memory "));
		break;
		
	case RFID_RESULT_INVALID_ARGS:
		wsprintf(szResult, _T(" Invalid Args "));
		break;
		
	case RFID_RESULT_UNEXPECTED:
		wsprintf(szResult, _T(" UnExpected "));
		break;
		
	case RFID_RESULT_FAILURE:
		wsprintf(szResult, _T(" Failure "));
		break;
		
	case RFID_RESULT_ALREADY_OPENED:
		wsprintf(szResult, _T(" Alreaddy Opened "));
		break;

	case RFID_RESULT_INVALID_DEVICE:
		wsprintf(szResult, _T(" Invalid Device "));
		break;

	case RFID_RESULT_NOT_CONNECTED:
		wsprintf(szResult, _T(" Not Connected "));
		break;
		
	case RFID_RESULT_NOT_DETECT:
		wsprintf(szResult, _T(" Not Detect "));
		break;
		
	case RFID_RESULT_ACCESS_ERROR:
		wsprintf(szResult, _T(" Access Error "));
		break;
		
	case RFID_RESULT_NOT_OPENED:
		wsprintf(szResult, _T(" Not Open "));
		break;
		
	case RFID_RESULT_COMMAND_ERROR:
		wsprintf(szResult, _T(" Command Error "));
		break;
		
	case RFID_RESULT_LOW_BATTERY:
		wsprintf(szResult, _T(" Low Battery "));
		break;
		
	case RFID_RESULT_UNKNOWN:
		wsprintf(szResult, _T(" Unknown "));
		break;
		
	case RFID_RESULT_NOT_SUPPORTED:
		wsprintf(szResult, _T(" Not Supported "));
		break;
		
	case RFID_RESULT_STOPPED:
		wsprintf(szResult, _T(" Stopped "));
		break;
		
	case RFID_RESULT_POWER_OFF:
		wsprintf(szResult, _T(" Power Off "));
		break;
	}
	this->m_listMessage.InsertItem(m_idx,_T(""));
	this->m_listMessage.SetItemText(m_idx,0,szResult);

	m_idx ++;
}