// RFIDDlg.cpp : implementation file
//



#include "stdafx.h"
#include "RFID.h"
#include "RFIDDlg.h"
#include "RFIDDef.h"
#ifdef _DEBUG
#define new DEBUG_NEW
#endif


#include "Read.h"
#include "Write.h"
#include "Lock.h"
#include "Kill.h"

#include<iostream>
#include<queue>


using namespace std;

#define WM_READER_EVENT (WM_USER+123)
CString SelectedTagValue;
// CRFIDDlg dialog

CRFIDDlg::CRFIDDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CRFIDDlg::IDD, pParent)
{
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CRFIDDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	DDX_Control(pDX, IDC_LIST_INVENTORY, m_listInventory);
	DDX_Control(pDX, IDC_BUTTON1, m_btnInventory);
	DDX_Control(pDX, IDC_COMBO_SESSION, m_nSession);
	DDX_Control(pDX, IDC_COMBO_TARGET, m_nTarget);
	DDX_Control(pDX, IDC_COMBO_POWER, m_cbPower);
	DDX_Control(pDX, IDC_COMBO4, m_cbQvalue);
	DDX_Control(pDX, IDC_BUTTON2, m_btnClear);
	DDX_Control(pDX, IDC_WRITE, m_btnWrite);
	DDX_Control(pDX, IDC_READ, m_btnRead);
	DDX_Control(pDX, IDC_LOCK, m_btnLock);
	DDX_Control(pDX, IDC_BUTTON3, m_btnKill);
}

BEGIN_MESSAGE_MAP(CRFIDDlg, CDialog)
#if defined(_DEVICE_RESOLUTION_AWARE) && !defined(WIN32_PLATFORM_WFSP)
	ON_WM_SIZE()
#endif
	ON_WM_COPYDATA()
	ON_WM_CLOSE()
	//}}AFX_MSG_MAP
	ON_BN_CLICKED(IDC_BUTTON1, &CRFIDDlg::OnBnClickedInventory)
	ON_BN_CLICKED(IDC_BUTTON2, &CRFIDDlg::OnBnClickedClear)
	ON_BN_CLICKED(IDC_READ, &CRFIDDlg::OnBnClickedRead)
	ON_BN_CLICKED(IDC_WRITE, &CRFIDDlg::OnBnClickedWrite)
	ON_BN_CLICKED(IDC_LOCK, &CRFIDDlg::OnBnClickedLock)
	ON_BN_CLICKED(IDC_BUTTON3, &CRFIDDlg::OnBnClickedButton3)
	ON_CBN_SELCHANGE(IDC_COMBO_SESSION, &CRFIDDlg::OnCbnSelchangeComboSession)
	ON_CBN_SELCHANGE(IDC_COMBO_TARGET, &CRFIDDlg::OnCbnSelchangeComboTarget)
	ON_CBN_SELCHANGE(IDC_COMBO_POWER, &CRFIDDlg::OnCbnSelchangeComboPower)
	ON_CBN_SELCHANGE(IDC_COMBO4, &CRFIDDlg::OnCbnSelchangeCombo4)
END_MESSAGE_MAP()


// CRFIDDlg message handlers

BOOL CRFIDDlg::OnInitDialog()
{
	CDialog::OnInitDialog();
	
	
	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon

	// TODO: Add extra initialization here
	CenterWindow(GetDesktopWindow());

	BeginWaitCursor();
	int		nWidth,
			nHeight;

	nWidth = GetSystemMetrics(SM_CXSCREEN);
	nHeight = GetSystemMetrics(SM_CYSCREEN);
	
	MoveWindow(-1, 0, nWidth + 1, nHeight - 26);

	
	hMain = m_hWnd;
	// create the rfid object
	RFID_RESULT result;
	result = RfidPowerOn();
	if(result != RFID_RESULT_SUCCESS){
		DisplayRfidResult(result);
		this->EndDialog(IDCANCEL);
		return 0;
	}
	result = RfidOpen();
	if(result != RFID_RESULT_SUCCESS){
		DisplayRfidResult(result);
		this->EndDialog(IDCANCEL);
		return 0;
	}
	RfidSetHwnd(this->m_hWnd);
	SleepWakeupNotificationSet(this->GetSafeHwnd());

	m_listInventory.InsertColumn(0,_T("EPC"),LVCFMT_LEFT,150);
	m_listInventory.InsertColumn(1, _T("count"), LVCFMT_LEFT, 100);

	m_nSession.AddString(_T("S0"));
	m_nSession.AddString(_T("S1"));
	m_nSession.AddString(_T("S2"));
	m_nSession.AddString(_T("S3"));

	RFIDSESSIONTYPE pSessionType;
	RfidGetSession(&pSessionType);
	switch(pSessionType){
		case RFID_SESSIONTYPE_0:
			m_nSession.SetCurSel(0);
			break;
		case RFID_SESSIONTYPE_1:
			m_nSession.SetCurSel(1);
			break;
		case RFID_SESSIONTYPE_2:
			m_nSession.SetCurSel(2);
			break;
		case RFID_SESSIONTYPE_3:
			m_nSession.SetCurSel(3);
			break;
		default:
			m_nSession.EnableWindow(FALSE);
			break;
	}

	m_nTarget.AddString(_T("A"));
	m_nTarget.AddString(_T("B"));
	m_nTarget.AddString(_T("AB"));

	RFIDINVENTORIEDSTATE pInventoryState;
	RfidGetInventoryTarget(&pInventoryState);
	switch(pInventoryState){
		case RFID_INVENTORIEDSTATE_A:
			m_nTarget.SetCurSel(0);
			break;
		case RFID_INVENTORIEDSTATE_B:
			m_nTarget.SetCurSel(1);
			break;
		case RFID_INVENTORIEDSTATE_AB:
			m_nTarget.SetCurSel(2);
			break;
		default:
			m_nTarget.EnableWindow(FALSE);
			break;
	}
	
	int i = 0;
	CString strTemp;
	for(i =0; i<=24 ; i++){
		strTemp.Format(_T("%d"),i);
		m_cbPower.AddString(strTemp);
	
	}
	UINT nMaxPower =0;
	UINT nPower =0;
	m_nMaxPower =0;
	RfidGetXcvrMaxPwr(&nMaxPower);
	RfidGetPowerLevel(&nPower);

	if(nMaxPower ==0)
		nMaxPower =300;
	CString str;
	strTemp.Format(_T("%d"),nMaxPower);
	str = strTemp.Mid(0,2);
	int powerValue = _ttoi(str);
	switch(powerValue){
		case 30:
			for(i = 25; i<=30; i++){
				strTemp.Format(_T("%d"),i);
				m_cbPower.AddString(strTemp);
			}
			m_nMaxPower = 30;
			break;
		case 28:
			for(i = 25; i<=28; i++){
				strTemp.Format(_T("%d"),i);
				m_cbPower.AddString(strTemp);
			}
			m_nMaxPower = 28;
			break;
		case 27:
			for(i = 25; i<=27; i++){
				strTemp.Format(_T("%d"),i);
				m_cbPower.AddString(strTemp);
			}
			m_nMaxPower = 27;
			break;
		case 24:
			m_nMaxPower = 24;
			break;
		default:
			m_nMaxPower = 30;
			for(i = 25; i<=30; i++){
				strTemp.Format(_T("%d"),i);
				m_cbPower.AddString(strTemp);
			}
			break;

	}
	CString cbPowerText;
	m_cbPower.SetCurSel(m_nMaxPower-nPower);
	
	for(i =0;i <=15;i++){
		strTemp.Format(_T("%d"),i);
		m_cbQvalue.AddString(strTemp);
	}

	UINT nQvalue;	
	RfidGetQValue(&nQvalue);
	m_cbQvalue.SetCurSel(nQvalue);


	
	exitThread = FALSE;
	
	threadDequeue = NULL;
	threadDequeue = AfxBeginThread(threadDequeueProc,(LPVOID)this,THREAD_PRIORITY_NORMAL);
	m_hEvent = CreateEvent(NULL,TRUE,FALSE,NULL);
	EndWaitCursor();
	return TRUE;  // return TRUE  unless you set the focus to a control
}

void CRFIDDlg::DisplayRfidResult(RFID_RESULT result)
{
	TCHAR szResult[MAX_PATH];
	memset(szResult, 0x00, sizeof(szResult));
	
	switch(result)
	{
	case RFID_RESULT_SUCCESS:
		wsprintf(szResult, _T(" Success "));
		break;
		
	case RFID_RESULT_OUTOFMEMORY:
		wsprintf(szResult, _T(" Out Of Memory "));
		break;
		
	case RFID_RESULT_INVALID_ARGS:
		wsprintf(szResult, _T(" Invalid Args "));
		break;
		
	case RFID_RESULT_UNEXPECTED:
		wsprintf(szResult, _T(" UnExpected "));
		break;
		
	case RFID_RESULT_FAILURE:
		wsprintf(szResult, _T(" Failure "));
		break;
		
	case RFID_RESULT_ALREADY_OPENED:
		wsprintf(szResult, _T(" Alreaddy Opened "));
		break;

	case RFID_RESULT_INVALID_DEVICE:
		wsprintf(szResult, _T(" Invalid Device "));
		break;

	case RFID_RESULT_NOT_CONNECTED:
		wsprintf(szResult, _T(" Not Connected "));
		break;
		
	case RFID_RESULT_NOT_DETECT:
		wsprintf(szResult, _T(" Not Detect "));
		break;
		
	case RFID_RESULT_ACCESS_ERROR:
		wsprintf(szResult, _T(" Access Error "));
		break;
		
	case RFID_RESULT_NOT_OPENED:
		wsprintf(szResult, _T(" Not Open "));
		break;
		
	case RFID_RESULT_COMMAND_ERROR:
		wsprintf(szResult, _T(" Command Error "));
		break;
		
	case RFID_RESULT_LOW_BATTERY:
		wsprintf(szResult, _T(" Low Battery "));
		break;
		
	case RFID_RESULT_UNKNOWN:
		wsprintf(szResult, _T(" Unknown "));
		break;
		
	case RFID_RESULT_NOT_SUPPORTED:
		wsprintf(szResult, _T(" Not Supported "));
		break;
		
	case RFID_RESULT_STOPPED:
		wsprintf(szResult, _T(" Stopped "));
		break;
		
	case RFID_RESULT_POWER_OFF:
		wsprintf(szResult, _T(" Power Off "));
		break;
	}
	
	AfxMessageBox(szResult);
}

void CRFIDDlg::SetErrorMessage(LPWSTR szBuffer, RFID_RESULT result){
	switch(result)
	{
	case RFID_RESULT_OUTOFMEMORY:
		wsprintf(szBuffer, _T("OUTOFMEMORY"));
		break;
	case RFID_RESULT_INVALID_ARGS:
		wsprintf(szBuffer, _T("INVALID_ARGS"));
		break;
	case RFID_RESULT_UNEXPECTED:
		wsprintf(szBuffer, _T("UNEXPECTED"));
		break;
	case RFID_RESULT_FAILURE:
		wsprintf(szBuffer, _T("FAILURE"));
		break;
	case RFID_RESULT_ALREADY_OPENED:
		wsprintf(szBuffer, _T("ALREADY_OPENED"));
		break;
	case RFID_RESULT_INVALID_DEVICE:
		wsprintf(szBuffer, _T("INVALID_DEVICE"));
		break;
	case RFID_RESULT_NOT_CONNECTED:
		wsprintf(szBuffer, _T("NOT_CONNECTED"));
		break;
	case RFID_RESULT_NOT_DETECT:
		wsprintf(szBuffer, _T("NOT_DETECT"));
		break;
	case RFID_RESULT_ACCESS_ERROR:
		wsprintf(szBuffer, _T("ACCESS_ERROR"));
		break;
	case RFID_RESULT_NOT_OPENED:
		wsprintf(szBuffer, _T("NOT_OPENED"));
		break;
	case RFID_RESULT_COMMAND_ERROR:
		wsprintf(szBuffer, _T("COMMAND_ERROR"));
		break;
	case RFID_RESULT_LOW_BATTERY:
		wsprintf(szBuffer, _T("LOW_BATTERY"));
		break;
	case RFID_RESULT_UNKNOWN:
		wsprintf(szBuffer, _T("UNKNOWN"));
		break;
	case RFID_RESULT_NOT_SUPPORTED:
		wsprintf(szBuffer, _T("NOT_SUPPORTED"));
		break;
	case RFID_RESULT_STOPPED:
		wsprintf(szBuffer, _T("STOPPED"));
		break;
	case RFID_RESULT_POWER_OFF:
		wsprintf(szBuffer, _T("POWER_OFF"));
		break;
	}

	AfxMessageBox(szBuffer);

}


#if defined(_DEVICE_RESOLUTION_AWARE) && !defined(WIN32_PLATFORM_WFSP)
void CRFIDDlg::OnSize(UINT /*nType*/, int /*cx*/, int /*cy*/)
{
	if (AfxIsDRAEnabled())
	{
		DRA::RelayoutDialog(
			AfxGetResourceHandle(), 
			this->m_hWnd, 
			DRA::GetDisplayMode() != DRA::Portrait ? 
			MAKEINTRESOURCE(IDD_RFID_DIALOG_WIDE) : 
			MAKEINTRESOURCE(IDD_RFID_DIALOG));
	}
}
#endif


void CRFIDDlg::OnBnClickedInventory()
{
	// TODO: ⿡ Ʈ ˸ ó ڵ带 ߰մϴ.
	CString sBtnInventory;

	m_btnInventory.GetWindowTextW(sBtnInventory);

	if(sBtnInventory.Compare(BTN_LABEL_STOP) !=0)
	{
		TCHAR szPattern[MAX_PATH] = _T("");
		UpdateData();

		m_isRunning = TRUE;
		SetEvent(m_hEvent);
		m_btnInventory.EnableWindow(FALSE);
		// Starts inventory(Read multiple tags)
		RFID_RESULT result = RfidReadEPC(FALSE,RFID_EPC_GEN2_MULTI_TAG,NULL,NULL);
		
		if(result != RFID_RESULT_SUCCESS){
			SetErrorMessage(szPattern, result);
			AfxMessageBox(szPattern);
			if(m_isRunning)
					m_isRunning = FALSE;
			m_btnInventory.SetWindowTextW(BTN_LABEL_START);
			m_btnInventory.EnableWindow(TRUE);
			setButtons(TRUE);
			return;
		}
		
		m_btnInventory.SetWindowTextW(BTN_LABEL_STOP);
		m_btnInventory.EnableWindow(TRUE);
		setButtons(FALSE);
	}else{
		// Stop inventory

		ResetEvent(m_hEvent);
		m_isRunning = FALSE;
		RfidStop();
		setButtons(TRUE);
	
	}

	m_listInventory.SetFocus();
}

BOOL CRFIDDlg:: OnCopyData(CWnd *pWnd, COPYDATASTRUCT *pCopyDataStruct){
	RFIDCALLBACKDATA * pData;
	int						nItemIdx = 0,	nItemCount = 0,
							nTemp = 0;
	CString					sTemp,			sReadCount;
	CTime					time;

	time							= CTime::GetCurrentTime();
	TCHAR szReadCount[100]			= _T("");
	TCHAR szResultData[MAX_PATH]	= _T("");
	TCHAR szTime[MAX_PATH]			= _T("");

		// A buffer to store the data
		pData = (RFIDCALLBACKDATA *)pCopyDataStruct->lpData;

		 // In order to read the results you should call GetResult function.
		RfidGetResult(szResultData,pData->CallbackType,pData->wParam,pData->lParam);
		RETAILMSG(1, (TEXT("\tApp, Data=%s \r\n\r\n"), szResultData));

		if(pData->CallbackType==RFIDCALLBACKTYPE_REPLY){
			RETAILMSG(_DBMSGFLG, (TEXT("[OnCopyData] -REPLY- \t[ %s ] \r\n"), szResultData));
			m_isRunning =FALSE;
			m_btnInventory.SetWindowTextW(BTN_LABEL_START);
		}

		// When the memory value is received from the RFID module
		if(pData->CallbackType==RFIDCALLBACKTYPE_DATA){
			//PlaySound( _T("\\Windows\\success.wav"), NULL, SND_ASYNC|SND_NOSTOP);
			RETAILMSG(_DBMSGFLG, (TEXT("[OnCopyData] -INVENTORIED- \t[ %s ] \r\n"), szResultData));


			qTags.push(szResultData);

		}else	// When the response is received from the RFID module
		{
			// inventory has been discontinued.
			RETAILMSG(_DBMSGFLG, (TEXT("[OnCopyData] -NO INVENTORIED- \t[ %s ] \r\n"), szResultData));
			m_isRunning =FALSE;
			m_btnInventory.SetWindowTextW(BTN_LABEL_START);
		
		}
		//break;
	//}


	return CDialog::OnCopyData(pWnd,pCopyDataStruct);
}

CString CRFIDDlg::GetSelectedTag(){
	if(m_listInventory.GetNextItem(-1,LVNI_SELECTED) <0)
		return NULL;
	int idx = m_listInventory.GetNextItem(-1,LVNI_SELECTED);

	RETAILMSG(1, (TEXT("[APP, GetSelectedTag] ->> GetSelectedTag \t[ %s ] \r\n"), m_listInventory.GetItemText(idx,0)));
	return m_listInventory.GetItemText(idx,0);

}


void CRFIDDlg::OnBnClickedClear()
{
	// TODO: ⿡ Ʈ ˸ ó ڵ带 ߰մϴ.
	m_listInventory.SetItemCount(0);
	m_listInventory.DeleteAllItems();

}

void CRFIDDlg::OnBnClickedRead()
{
	// TODO: ⿡ Ʈ ˸ ó ڵ带 ߰մϴ.
	SelectedTagValue = GetSelectedTag();
	Read dlg;
	dlg.DoModal();
	
	RfidSetOperationTime(0);
}

void CRFIDDlg::OnBnClickedWrite()
{
	// TODO: ⿡ Ʈ ˸ ó ڵ带 ߰մϴ.
	SelectedTagValue = GetSelectedTag();
	CWrite dlg;
	dlg.DoModal();

	RfidSetOperationTime(0);
}

void CRFIDDlg::OnBnClickedLock()
{
	// TODO: ⿡ Ʈ ˸ ó ڵ带 ߰մϴ.
	SelectedTagValue = GetSelectedTag();
	CLock dlg;
	dlg.DoModal();

	RfidSetOperationTime(0);
}

void CRFIDDlg::OnBnClickedButton3()
{
	// TODO: ⿡ Ʈ ˸ ó ڵ带 ߰մϴ.
	SelectedTagValue = GetSelectedTag();
	CKill dlg;
	dlg.DoModal();

	RfidSetOperationTime(0);
}

void CRFIDDlg::OnCbnSelchangeComboSession()
{
	// TODO: ⿡ Ʈ ˸ ó ڵ带 ߰մϴ.
	switch(m_nSession.GetCurSel()){
		case 0:RfidSetSession(RFID_SESSIONTYPE_0);
			break;
		case 1: RfidSetSession(RFID_SESSIONTYPE_1);
			break;
		case 2: RfidSetSession(RFID_SESSIONTYPE_2);
			break;
		case 3: RfidSetSession(RFID_SESSIONTYPE_3);
			break;

	
	}

}

void CRFIDDlg::OnCbnSelchangeComboTarget()
{
	// TODO: ⿡ Ʈ ˸ ó ڵ带 ߰մϴ.
	switch(m_nTarget.GetCurSel()){
		case 0:RfidSetInventoryTarget(RFID_INVENTORIEDSTATE_A);
			break;
		case 1:RfidSetInventoryTarget(RFID_INVENTORIEDSTATE_B);
			break;
		case 2:RfidSetInventoryTarget(RFID_INVENTORIEDSTATE_AB);
			break;
	}
}
void CRFIDDlg::OnCbnSelchangeComboPower()
{
	// TODO: ⿡ Ʈ ˸ ó ڵ带 ߰մϴ.

	UINT nPower = 0;
	nPower = m_cbPower.GetCurSel();
	RfidSetPowerLevel(m_nMaxPower-nPower);
}

void CRFIDDlg::OnCbnSelchangeCombo4()
{
	// TODO: ⿡ Ʈ ˸ ó ڵ带 ߰մϴ.
	RfidSetQValue((UINT)m_cbQvalue.GetCurSel());
}

BOOL CRFIDDlg::PreTranslateMessage(MSG *pMsg){
	CString sBtnInventory;

	switch(pMsg->message)
	{
	case WM_KEYDOWN:
		switch(pMsg->wParam)
		{
		case VK_F7:
		case VK_F8:
		case VK_F9:
		case VK_F18:
		case VK_F19:
				OnBnClickedInventory();
			break;
		}
		break;
		case WM_KEYUP:
			switch(pMsg->wParam)
			{
			case VK_F7:
			case VK_F8:
			case VK_F9:
			case VK_F18:
			case VK_F19:
				this->m_btnInventory.GetWindowTextW(sBtnInventory);
					if(sBtnInventory.Compare(BTN_LABEL_STOP) == 0)
					{
						OnBnClickedInventory();
					}
				break;
			}
			break;
	}
	return CDialog::PreTranslateMessage(pMsg);
}

void CRFIDDlg::OnClose(){
	if(m_isRunning == TRUE){
	
		AfxMessageBox(L"RFID is running, Please STOP inventory", MB_OK, 0);
		return;
	}
	RfidClose();
	RfidPowerOff();
	exitThread = TRUE;

	if(threadDequeue != NULL){
		threadDequeue->Delete();
		threadDequeue = NULL;
	}
	if(m_hEvent != NULL){
		CloseHandle(m_hEvent);
		m_hEvent = NULL;
	
	}
	CDialog::OnClose();
}

void CRFIDDlg::OnOK(){
	if(m_isRunning == TRUE){
		AfxMessageBox(L"RFID is running, Please STOP inventory", MB_OK, 0);
		return;
	}
	RfidClose();
	RfidPowerOff();
	exitThread = TRUE;
	if(threadDequeue != NULL){
		threadDequeue->Delete();
		threadDequeue = NULL;
	}
	if(m_hEvent != NULL){
		CloseHandle(m_hEvent);
		m_hEvent = NULL;
	
	}
	CDialog::OnOK();

}

void CRFIDDlg::OnCancel(){
	if(m_isRunning == TRUE){
		AfxMessageBox(L"RFID is running, Please STOP inventory", MB_OK, 0);
		return;
	}
	CDialog::OnCancel();
}

UINT CRFIDDlg::threadDequeueProc(LPVOID _mothod){
	RETAILMSG(1, (TEXT("[APP, threadDequeueProc] ->> threadDequeueProc start <<- \r\n")));

	CRFIDDlg *fir = (CRFIDDlg*)_mothod;
	
	CRFIDDlg *dlg = (CRFIDDlg*)AfxGetApp()->m_pMainWnd;
	TCHAR szReadCount[100]			= _T("");
	TCHAR szResultData[MAX_PATH]	= _T("");
	int						nItemIdx = 0,	nItemCount = 0,
							nTemp = 0;
	CString					sTemp,			sReadCount;
	CTime					time;
	CString					sResultDataTemp;
	DWORD dwErr = 0;
	int flag = 0;
	while(!dlg->exitThread){
		
		::WaitForSingleObject(dlg->m_hEvent,1000);
		
		while(dlg->qTags.size()>0 || dlg->m_isRunning == TRUE){
			

			if(dlg->qTags.size()<=0){
				Sleep(1);
				continue;
			}
			flag = 0;
			// Cut only the data from buffer
			sResultDataTemp = dlg->qTags.front();
			wsprintf(szResultData, _T("%s"), sResultDataTemp);
			
			dlg->qTags.pop();
			
			if(szResultData != _T(""))
			{
				RETAILMSG(1, (TEXT("[APP, threadDequeueProc] ->> szResultData \t[ %s ] \r\n"), szResultData));
				
				::SendMessage(dlg->hMain,WM_READER_EVENT,0,(LPARAM)szResultData);
			}
			else
			{
				RETAILMSG(1, (TEXT("[APP, threadDequeueProc] ->> szResultData is NULL \t[ %s ] \r\n"), szResultData));
				Sleep(1);
			}
			
		}
	
	}
	RETAILMSG(1, (TEXT("[APP, threadDequeueProc] ->> threadDequeueProc end <<- \r\n")));
return 0;
}

void CRFIDDlg::setButtons(BOOL enable){
	m_btnClear.EnableWindow(enable);
	m_btnRead.EnableWindow(enable);
	m_btnWrite.EnableWindow(enable);
	m_btnLock.EnableWindow(enable);
	m_btnKill.EnableWindow(enable);

	m_nSession.EnableWindow(enable);
	m_nTarget.EnableWindow(enable);
	m_cbPower.EnableWindow(enable);
	m_cbQvalue.EnableWindow(enable);
}
LRESULT CRFIDDlg::WindowProc(UINT message, WPARAM wParam, LPARAM lParam)
{
	// TODO: ⿡ Ưȭ ڵ带 ߰ /Ǵ ⺻ Ŭ ȣմϴ.
	

	int						nItemIdx = 0,	nItemCount = 0,
							nTemp = 0,		nIdx;
	CString					sTemp,			sReadCount, sReadData;
	TCHAR szReadCount[100] = _T("");
	TCHAR szResultData[MAX_PATH]	= _T("");
	CString sBtnInventory;
	int flag = 0;
	switch(message)
	{
	case WM_READER_EVENT:
		

		sReadData.Format(_T("%s"),lParam);
		wsprintf(szResultData,_T("%s"),sReadData);
		RETAILMSG(1, (TEXT("[APP, WindowProc] ->> WM_READER_EVENT DATA \t[ %s ] \r\n"), szResultData));
		nItemCount = m_listInventory.GetItemCount();
				
				for(nIdx = 0; nIdx < nItemCount; nIdx ++)
				{
					sTemp = m_listInventory.GetItemText(nIdx,0);

					if(sTemp.Compare(szResultData) ==0)
					{
						sReadCount = m_listInventory.GetItemText(nIdx, 1);
						
						wsprintf(szReadCount, _T("%s"), sReadCount);

						nTemp = _ttoi(szReadCount);
						
						sReadCount.Empty();
						sReadCount.Format(_T("%d"), nTemp + 1);
						m_listInventory.SetItemText(nIdx, 1, sReadCount);
						flag =1;
						break;
					}
				
				}
				if(flag == 0){
				nItemIdx = m_listInventory.InsertItem(nIdx, szResultData);
				m_listInventory.SetItemText(nItemIdx, 1, _T("1"));
				}
		break;
	}


	return CDialog::WindowProc(message, wParam, lParam);
}
