// SysSvcDlg.cpp : implementation file
//

#include "stdafx.h"
#include "SysSvc.h"
#include "SysSvcDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#endif

// CSysSvcDlg dialog

CSysSvcDlg::CSysSvcDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CSysSvcDlg::IDD, pParent)
	, m_nTimeOutValue(0)
	, m_nBrightValue(0)
{
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);

	
}

void CSysSvcDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	DDX_Control(pDX, IDC_DeviceID1, tbxDeviceId);
	DDX_Control(pDX, IDC_WIFI, chkWiFi);
	DDX_Control(pDX, IDC_BLUETOOTH, chkBluetooth);
	DDX_Control(pDX, IDC_MODE, cbxMode);
	DDX_Control(pDX, IDC_KEYPADSTATUS, cbxKeypadStatus);
	DDX_Control(pDX, IDC_FLASHLIGHT, cbkFlashLight);
	DDX_Control(pDX, IDC_VIBRATOR, chkVibrator);
	DDX_Text(pDX, IDC_TURNOFFDEVICE1, m_nTurnOffDevice);
	DDX_Control(pDX, IDC_TURNOFFDEVICE1, m_tbxTurnOffDevice);
	DDX_Text(pDX, IDC_TURNOFFBACKLIGHT, m_nTimeOutValue);
	DDX_Text(pDX, IDC_BACKLIGHTBRIGHTNESS, m_nBrightValue);
	DDX_Control(pDX, IDC_TURNOFFBACKLIGHT, m_ntbxTimeOutValue);
	DDX_Control(pDX, IDC_BACKLIGHTBRIGHTNESS, m_tbxBrightValue);
	DDV_MinMaxInt(pDX, m_nTimeOutValue, 0, 100);
	DDV_MinMaxInt(pDX, m_nBrightValue, 0, 100);
	DDX_Control(pDX, IDC_SPIN1, m_SPIN_SusPendValue);
	DDX_Control(pDX, IDC_BACKLIGHT, m_SPIN_TimeOutValue);
	DDX_Control(pDX, IDC_SPIN_BACKLIGHTBRIGHTNESS, m_SPIN_BrightnessValue);
}

BEGIN_MESSAGE_MAP(CSysSvcDlg, CDialog)
#if defined(_DEVICE_RESOLUTION_AWARE) && !defined(WIN32_PLATFORM_WFSP)
	ON_WM_SIZE()
#endif
	//}}AFX_MSG_MAP
	ON_BN_CLICKED(IDC_WIFI, &CSysSvcDlg::OnBnClickedWifi)
	ON_BN_CLICKED(IDC_BLUETOOTH, &CSysSvcDlg::OnBnClickedBluetooth)
	ON_BN_CLICKED(IDC_VIBRATOR, &CSysSvcDlg::OnBnClickedVibrator)
	ON_BN_CLICKED(IDC_FLASHLIGHT, &CSysSvcDlg::OnBnClickedFlashlight)
	ON_CBN_SELCHANGE(IDC_MODE, &CSysSvcDlg::OnCbnSelchangeMode)
	ON_CBN_SELCHANGE(IDC_KEYPADSTATUS, &CSysSvcDlg::OnCbnSelchangeKeypadstatus)
	ON_BN_CLICKED(IDC_BUTTON1, &CSysSvcDlg::OnBnClickedButton1)
	ON_BN_CLICKED(IDC_BUTTON2, &CSysSvcDlg::OnBnClickedButton2)
	ON_BN_CLICKED(IDC_BUTTON3, &CSysSvcDlg::OnBnClickedButton3)
	ON_BN_CLICKED(IDC_BUTTON4, &CSysSvcDlg::OnBnClickedButton4)
	ON_BN_CLICKED(IDC_BUTTON5, &CSysSvcDlg::OnBnClickedButton5)
	ON_BN_CLICKED(IDC_BUTTON6, &CSysSvcDlg::OnBnClickedButton6)
END_MESSAGE_MAP()


// CSysSvcDlg message handlers

BOOL CSysSvcDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	BeginWaitCursor();
	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon

	// TODO: Add extra initialization here
	CenterWindow(GetDesktopWindow());
	keypadStatus = KBD_STATUS_NUMERIC;
	if (AllocSysSvc() != SYSSVC_RESULT_SUCCESS)
	{
		AfxMessageBox(_T("AllocSysSvc Fail"));
	}


	m_SPIN_BrightnessValue.SetRange(0,100);
	m_SPIN_TimeOutValue.SetRange(0,100);
	m_SPIN_SusPendValue.SetRange(0,10000);


	UCHAR ucDeviceId[38];
	memset(ucDeviceId, 0x00, sizeof(ucDeviceId));

	WCHAR wcsDeviceID[38];
	memset(wcsDeviceID, 0x00, sizeof(wcsDeviceID));

	// Get Device ID
	if(ReadDeviceId(ucDeviceId) != SYSSVC_RESULT_SUCCESS){
		AfxMessageBox(_T("ReadDeviceID Fail"));
		EndWaitCursor();
		return FALSE;
	}
	mbstowcs(wcsDeviceID, (char*)ucDeviceId, 16);

	tbxDeviceId.SetWindowTextW(wcsDeviceID);

	// Get hardware device options
	hwOptions;
	GetHardwareOptions(&hwOptions);
	if(hwOptions.BarcodeType==HW_TYPE_BARCODE_NONE){
		EndWaitCursor();
		return FALSE;
	}

	int nStatus=0;

	// Check WiFi Power Status
	chkWiFi.EnableWindow(hwOptions.WLANType==HW_TYPE_WLAN_NONE? FALSE:TRUE);

	if(hwOptions.WLANType != HW_TYPE_WLAN_NONE){
		result = GetWirelessDevicesPowerState(WIRELESS_DEVICE_WLAN, &nStatus);
		if(result != SYSSVC_RESULT_SUCCESS){
			EndWaitCursor();
			return FALSE;
		}
		chkWiFi.SetCheck(nStatus==1? TRUE:FALSE);
	}

	// Check Bluetooth Power Status
	chkBluetooth.EnableWindow(hwOptions.BluetoothType==HW_TYPE_BLUETOOTH_NONE? FALSE:TRUE);
	if(hwOptions.WLANType != HW_TYPE_BLUETOOTH_NONE){
		result = GetWirelessDevicesPowerState(WIRELESS_DEVICE_BLUETOOTH,&nStatus);
		if(result != SYSSVC_RESULT_SUCCESS){
			EndWaitCursor();
			return FALSE;
		}
		chkBluetooth.SetCheck(nStatus==1? TRUE:FALSE);
	}

	cbxMode.AddString(_T("On battery powr,"));
	cbxMode.AddString(_T("On external power,"));
	cbxMode.SetCurSel(0);

	ReadPowerAndBacklightStatus(0);

	// Check hardware keyboard input status
	result = GetKBDStatus(&keypadStatus);

	if(result != SYSSVC_RESULT_SUCCESS){
		EndWaitCursor();
		return FALSE;
		
	}

	cbxKeypadStatus.AddString(_T("Lower case"));
	cbxKeypadStatus.AddString(_T("Numeric"));
	cbxKeypadStatus.AddString(_T("Upper case"));
	switch(keypadStatus){
		case KBD_STATUS_LOWER_CASE:
			cbxKeypadStatus.SetCurSel(0);
			break;
		case KBD_STATUS_NUMERIC:
			cbxKeypadStatus.SetCurSel(1);
			break;
		case KBD_STATUS_UPPER_CASE:
			cbxKeypadStatus.SetCurSel(2);
			break;
	}

	EndWaitCursor();
	return TRUE;  // return TRUE  unless you set the focus to a control
}


BOOL CSysSvcDlg::DestroyWindow() 
{
	// TODO: Add your specialized code here and/or call the base class
	return CDialog::DestroyWindow();
}

void CSysSvcDlg::ReadPowerAndBacklightStatus(char mode){
	UpdateData(TRUE);
	WORD nValue =0;
	SYSSVC_RESULT result;
	CString str;
	result = SuspendReadTimeoutValue(mode,&nValue);
	if(result != SYSSVC_RESULT_SUCCESS)
		AfxMessageBox(_T("SuspendReadTimeoutValue Fail"));	
	str.Format(_T("%d"),nValue);
	m_nTurnOffDevice = nValue;
	m_tbxTurnOffDevice.SetWindowTextW(str);

	result = BacklightReadTimeoutValue(mode,&nValue);
	if(result != SYSSVC_RESULT_SUCCESS)
		AfxMessageBox(_T("BacklightReadTimeoutValue Fail"));
	str.Format(_T("%d"),nValue);
	m_nTimeOutValue = nValue;
	m_ntbxTimeOutValue.SetWindowTextW(str);

	result = BacklightReadBrightness(mode, &nValue);
	if(result != SYSSVC_RESULT_SUCCESS)
		AfxMessageBox(_T("BacklightReadBrightness Fail"));
	str.Format(_T("%d"),nValue);
	m_nBrightValue = nValue;
	m_tbxBrightValue.SetWindowTextW(str);
	
	
	UpdateData(FALSE);
	
}




#if defined(_DEVICE_RESOLUTION_AWARE) && !defined(WIN32_PLATFORM_WFSP)
void CSysSvcDlg::OnSize(UINT /*nType*/, int /*cx*/, int /*cy*/)
{
	if (AfxIsDRAEnabled())
	{
		DRA::RelayoutDialog(
			AfxGetResourceHandle(), 
			this->m_hWnd, 
			DRA::GetDisplayMode() != DRA::Portrait ? 
			MAKEINTRESOURCE(IDD_SYSSVC_DIALOG_WIDE) : 
			MAKEINTRESOURCE(IDD_SYSSVC_DIALOG));
	}
}
#endif


void CSysSvcDlg::OnBnClickedWifi()
{
	// TODO: ⿡ Ʈ ˸ ó ڵ带 ߰մϴ.
	BOOL turnOn = chkWiFi.GetCheck();

	BeginWaitCursor();
	// Turn on/off the WiFi power.
	result = SetWirelessDevicesPowerState(WIRELESS_DEVICE_WLAN, turnOn ? 1:0);
	if(result != SYSSVC_RESULT_SUCCESS){
		PlaySound(_T("\\Windows\\Fail.wav"), NULL, SND_ASYNC);
	}else{
		PlaySound(_T("\\Windows\\Success.wav"), NULL, SND_ASYNC);
	}
	EndWaitCursor();

}

void CSysSvcDlg::OnBnClickedBluetooth()
{
	// TODO: ⿡ Ʈ ˸ ó ڵ带 ߰մϴ.
	BOOL turnOn = chkBluetooth.GetCheck();

	BeginWaitCursor();
	 // Turn on/off the Bluetooth power.
	result = SetWirelessDevicesPowerState(WIRELESS_DEVICE_BLUETOOTH, turnOn?1:0);
	if(result != SYSSVC_RESULT_SUCCESS){
		PlaySound(_T("\\Windows\\Fail.wav"), NULL, SND_ASYNC);
	}else{
		PlaySound(_T("\\Windows\\Success.wav"), NULL, SND_ASYNC);
	}
	EndWaitCursor();

}



void CSysSvcDlg::OnBnClickedVibrator()
{
	// TODO: ⿡ Ʈ ˸ ó ڵ带 ߰մϴ.
	BOOL turnOn = chkVibrator.GetCheck();

	BeginWaitCursor();
	// Turn on/off the Vibrator power.
	result = SetVibratorEnable(turnOn);
	if(result != SYSSVC_RESULT_SUCCESS){
		PlaySound(_T("\\Windows\\Fail.wav"), NULL, SND_ASYNC);
	}else{
		PlaySound(_T("\\Windows\\Success.wav"), NULL, SND_ASYNC);
	}
	EndWaitCursor();
}

void CSysSvcDlg::OnBnClickedFlashlight()
{
	// TODO: ⿡ Ʈ ˸ ó ڵ带 ߰մϴ.
	BOOL turnOn = chkVibrator.GetCheck();

	BeginWaitCursor();
	// Turn on/off the flash light
	result = EnableFlashLight(turnOn);
	if(result != SYSSVC_RESULT_SUCCESS){
		PlaySound(_T("\\Windows\\Fail.wav"), NULL, SND_ASYNC);
	}else{
		PlaySound(_T("\\Windows\\Success.wav"), NULL, SND_ASYNC);
	}
	EndWaitCursor();
}

void CSysSvcDlg::OnCbnSelchangeMode()
{
	// TODO: ⿡ Ʈ ˸ ó ڵ带 ߰մϴ.
	int mode = cbxMode.GetCurSel() ==0? MODE_BAT: MODE_AC;
	ReadPowerAndBacklightStatus(mode);
}


void CSysSvcDlg::OnCbnSelchangeKeypadstatus()
{
	// TODO: ⿡ Ʈ ˸ ó ڵ带 ߰մϴ.
	switch(cbxKeypadStatus.GetCurSel()){
		case 0:
			keypadStatus = KBD_STATUS_LOWER_CASE;
			break;
		case 1:
			keypadStatus = KBD_STATUS_NUMERIC;
			break;
		case 2:
			keypadStatus = KBD_STATUS_UPPER_CASE;
			break;
	}
	// Change hardware keyboard input status
    // Make sure that the icon changes in the task bar.
	result = SetKBDStatus(keypadStatus);
	if(result != SYSSVC_RESULT_SUCCESS){
		PlaySound(_T("\\Windows\\Fail.wav"), NULL, SND_ASYNC);
	}

}




void CSysSvcDlg::OnBnClickedButton1()
{
	// TODO: ⿡ Ʈ ˸ ó ڵ带 ߰մϴ.
	// perform a soft reset.
	SoftReset();
}

void CSysSvcDlg::OnBnClickedButton2()
{
	// TODO: ⿡ Ʈ ˸ ó ڵ带 ߰մϴ.
	// enter the suspend state
	EnterSuspendState();
}

void CSysSvcDlg::OnBnClickedButton3()
{
	// TODO: ⿡ Ʈ ˸ ó ڵ带 ߰մϴ.
	
	 // Get hardware device options
	result = GetHardwareOptions(&hwOptions);
	if(result != SYSSVC_RESULT_SUCCESS){
		PlaySound(_T("\\Windows\\Fail.wav"), NULL, SND_ASYNC);
	}else{
		// List the hardware device option status of the PDA you are using.
		PlaySound(_T("\\Windows\\Success.wav"), NULL, SND_ASYNC);
		CString msg =NULL;
		CString data;
		CString str1;
		
		str1.Format(_T("Barcode : %s\r\n"), hwOptions.BarcodeType == HW_TYPE_BARCODE_NONE ? _T("---") : _T("Available"));
		data.Append(str1);
		str1.Format(_T("Bluetooth : %s\r\n"), hwOptions.BluetoothType == HW_TYPE_BLUETOOTH_NONE ? _T("---") : _T("Available"));
		data.Append(str1);
		str1.Format(_T("Camera : %s\r\n"), hwOptions.CamType == HW_TYPE_CAM_NONE ? _T("---") : _T("Available"));
		data.Append(str1);
		str1.Format(_T("FingerPrint : %s\r\n"), hwOptions.FingerPrintType == HW_TYPE_FINGER_PRINT_NONE ? _T("---") : _T("Available"));
		data.Append(str1);
		str1.Format(_T("GPS : %s\r\n"), hwOptions.GPSType == HW_TYPE_GPS_NONE ? _T("---") : _T("Available"));
		data.Append(str1);
		str1.Format(_T("RFID HF : %s\r\n"), hwOptions.HFType == HW_TYPE_HF_NONE ? _T("---") : _T("Available"));
		data.Append(str1);
		str1.Format(_T("Modem : %s\r\n"), hwOptions.ModemType == HW_TYPE_MODEM_NONE ? _T("---") : _T("Available"));
		data.Append(str1);
		str1.Format(_T("MSR : %s\r\n"), hwOptions.MSRType == HW_TYPE_MSR_NONE ? _T("---") : _T("Available"));
		data.Append(str1);
		str1.Format(_T("Printer : %s\r\n"), hwOptions.PrinterType == HW_TYPE_PRINTER_NONE ? _T("---") : _T("Available"));
		data.Append(str1);
		str1.Format(_T("SmartCard : %s\r\n"), hwOptions.SmartCardType == HW_TYPE_SMARTCARD_NONE ? _T("---") : _T("Available"));
		data.Append(str1);
		str1.Format(_T("RFID UHF : %s\r\n"), hwOptions.UHFType == HW_TYPE_UHF_NONE ? _T("---") : _T("Available"));
		data.Append(str1);
		str1.Format(_T("WiFi : %s\r\n"), hwOptions.WLANType == HW_TYPE_WLAN_NONE ? _T("---") : _T("Available"));
		data.Append(str1);
		 AfxMessageBox(data);
	}
}

void CSysSvcDlg::OnBnClickedButton4()
{
	// TODO: ⿡ Ʈ ˸ ó ڵ带 ߰մϴ.
	UpdateData(TRUE);
	/*
    *  - Windows Mobile -
    *  MODE_BAT : Min:0 ~ Max:300
    *  MODE_AC : Min:0 ~ Max:1800
    *  
    * - Windows CE -
    *  MODE_BAT : Min:0 ~ Max:300
    *  MODE_AC : Min:0 ~ Max:1800
    * */

	// Set the in seconds.
    // if nValue is 0, The PDA will not turn off.
	RETAILMSG(1, (TEXT("+- OnButtonSuspendtimewrite, m_nTurnOffDevice:%d  \r\n"), m_nTurnOffDevice));
	if (SuspendWriteTimeoutValue(cbxMode.GetCurSel(), m_nTurnOffDevice) != SYSSVC_RESULT_SUCCESS)
	{
		AfxMessageBox(_T("SuspendWriteTimeoutValue Fail "));
		return;
	}
}



void CSysSvcDlg::OnBnClickedButton5()
{
	// TODO: ⿡ Ʈ ˸ ó ڵ带 ߰մϴ.
	UpdateData(TRUE);

	/*
    *  - Windows Mobile -
    *  MODE_BAT : Min:0 ~ Max:300
    *  MODE_AC : Min:0 ~ Max:600
    *  
    * - Windows CE -
    *  MODE_BAT : Min:0 ~ Max:300
    *  MODE_AC : Min:0 ~ Max:300
    * */

	RETAILMSG(1, (TEXT("+- OnButtonSuspendtimewrite, m_nTimeOutValue:%d  \r\n"), m_nTimeOutValue));
	// Set the value in seconds.
    // if nValue is 0, The backlight will not turn off.
	if(BacklightWriteTimeoutValue(cbxMode.GetCurSel(), m_nTimeOutValue) != SYSSVC_RESULT_SUCCESS)
	{
		AfxMessageBox(_T("Timeout Write BacklightWriteTimeoutValue Fail"));
		return;
	}
}

void CSysSvcDlg::OnBnClickedButton6()
{
	// TODO: ⿡ Ʈ ˸ ó ڵ带 ߰մϴ.
	UpdateData(TRUE);
	/*
    *  - Windows Mobile -
    *  Min:0 ~ Max:25
    *  
    * - Windows CE -
    *  Min:0 ~ Max:100
    
    * */
	RETAILMSG(1, (TEXT("+- BacklightWriteBrightness, m_nBrightValue:%d  \r\n"), m_nBrightValue));
	 // Sets the brightness value corresponding to the mode.
	if(BacklightWriteBrightness(cbxMode.GetCurSel(), m_nBrightValue) != SYSSVC_RESULT_SUCCESS)
	{
		AfxMessageBox(_T("Timeout Write BacklightWriteTimeoutValue Fail"));
		return;
	}

}
