#ifndef __CBARCODE__1D__CONFIG__API__H__
#define __CBARCODE__1D__CONFIG__API__H__

#define CBarcodeApi_API extern "C" __declspec(dllexport)

#pragma pack(push , 1)
typedef enum {
    SYMBOL_1D_UPCA = 0, 	// 0x01
    SYMBOL_1D_UPCE,	// 0x02
    SYMBOL_1D_UPCE1,	// 0x0C
    SYMBOL_1D_EAN8,	// 0x04
    SYMBOL_1D_EAN13,	// 0x03
    SYMBOL_1D_BOOKLAND,	// 
    SYMBOL_1D_CODE128,
    SYMBOL_1D_UCCEAN128,
    SYMBOL_1D_ISBT128,
    SYMBOL_1D_CODE39,
    SYMBOL_1D_TRIOPTIC39,
    SYMBOL_1D_CODE93,
    SYMBOL_1D_CODE11,
    SYMBOL_1D_INTERLEAVED25,
    SYMBOL_1D_DISCRETE25,
    SYMBOL_1D_CHINESE25,
    SYMBOL_1D_CODABAR,
    SYMBOL_1D_MSI,
    SYMBOL_1D_RSS14,
    SYMBOL_1D_RSSLIMITED,
    SYMBOL_1D_RSSEXPANDED,
    NUM_OF_1D_SYMBOLOGIES
}SYMBOLOGIES_1D;

typedef struct{
	BOOL bUPCAEnabled;
	BOOL bUPCEEnabled;
	BOOL bUPCE1Enabled;
	BOOL bEAN8Enabled;
	BOOL bEAN13Eanbled;
	BOOL bBooklandEnabled;
	BOOL bUCCEAN128Enabled;
	BOOL bEANZeroExtend;
	BOOL bConvertEAN8ToEAN13;
	WORD nDecodeUPCEANSupplemental;
	WORD nDecodeUPCEANSupplementalRedundancy;
	WORD nUPCEANSecurityLevel;
	BOOL bConvertUPCEToUPCA;
	BOOL bConvertUPCE1ToUPCA;
	BOOL bXmitUPCACheckChar;
	BOOL bXmitUPCECheckChar;
	BOOL bXmitUPCE1CheckChar;
	WORD nUPCAPreamble;
	WORD nUPCEPreamble;
	WORD nUPCE1Preamble;
	BOOL bUCCCouponExtendedCode;
}CONFIG_1D_UPCEAN;

typedef struct{
	BOOL bEnabled;
}CONFIG_1D_CODE128;

typedef struct{
	BOOL bEnabled;
}CONFIG_1D_ISBT128;

typedef struct{
	BOOL bEnabled;
	WORD nMinLength;
	WORD nMaxLength;
	BOOL bCheckDigitVerify;
	BOOL bXmitCheckDigit;
	BOOL bFullAscii;
	BOOL bConvertCode39ToCode32;
	BOOL bCode32Prefix;
	BOOL bEnableTriopticCode39;
}CONFIG_1D_CODE39;

typedef struct{
	BOOL bEnabled;
	WORD nMinLength;
	WORD nMaxLenght;
}CONFIG_1D_CODE93;

typedef struct{
	BOOL bEnabled;
	WORD nMinLength;
	WORD nMaxLength;
	BOOL bCheckDigitVerify;
	BOOL bXmitCheckDigit;
}CONIFG_1D_CODE11;

typedef struct{
	BOOL bEnabled;
	WORD nMinLength;
	WORD nMaxLength;
	WORD nCheckDigitVerify;
	BOOL bXmitCheckDigit;
	BOOL bConvertI2of5ToEAN13;
}CONFIG_1D_INTERLEAVED25;

typedef struct{
	BOOL bEnabled;
	WORD nMinLength;
	WORD nMaxLength;
}CONFIG_1D_DISCRETE25;

typedef struct{
	BOOL bEnabled;
}CONFIG_1D_CHINESE25;

typedef struct{
	BOOL bEnabled;
	WORD nMinLength;
	WORD nMaxLength;
	BOOL bCLSIEditing;
	BOOL bNOTISEditing;
}CONFIG_1D_CODABAR;

typedef struct{
	BOOL bEnabled;
	WORD nMinLength;
	WORD nMaxLength;
	BOOL bCheckDigitVerify;
	BOOL bXmitCheckDigit;
	BOOL bCheckDigitAlgorithm;
}CONFIG_1D_MSI;

typedef struct{
	BOOL bRSS14Enabled;
	BOOL bRSSLimitedEnabled;
	BOOL bRSSExpandedEnabled;
	BOOL bConvertRSSToUPCEAN;
}CONFIG_1D_RSS;

#pragma pack(pop)

#endif

















