#ifndef __CBARCODE__2DSWD__CONFIG__API__H__
#define __CBARCODE__2DSWD__CONFIG__API__H__

#define CBarcodeApi_API extern "C" __declspec(dllexport)

typedef enum {
    SYMBOL_2DSWD_AZTEC = 0,
    SYMBOL_2DSWD_MESA,
    SYMBOL_2DSWD_CODABAR,		/* 1D, 2D */
    SYMBOL_2DSWD_CODE11,		/* 1D, 2D */
    SYMBOL_2DSWD_CODE128,		/* 1D, 2D */
    SYMBOL_2DSWD_CODE39,		/* 1D, 2D */
    SYMBOL_2DSWD_CODE49,
    SYMBOL_2DSWD_CODE93,		/* 1D, 2D */
    SYMBOL_2DSWD_COMPOSITE,
    SYMBOL_2DSWD_DATAMATRIX,
    SYMBOL_2DSWD_EAN8,		/* 1D, 2D */
    SYMBOL_2DSWD_EAN13,		/* 1D, 2D */
    SYMBOL_2DSWD_INT25,		/* 1D, 2D */
    SYMBOL_2DSWD_MAXICODE,
    SYMBOL_2DSWD_MICROPDF,
    SYMBOL_2DSWD_OCR,
    SYMBOL_2DSWD_PDF417,
    SYMBOL_2DSWD_POSTNET,
    SYMBOL_2DSWD_QR,
    SYMBOL_2DSWD_RSS,
    SYMBOL_2DSWD_UPCA,		/* 1D, 2D */
    SYMBOL_2DSWD_UPCE0,		/* 1D, 2D */
    SYMBOL_2DSWD_UPCE1,		/* 1D, 2D */
    SYMBOL_2DSWD_ISBT,
    SYMBOL_2DSWD_BPO,
    SYMBOL_2DSWD_CANPOST,
    SYMBOL_2DSWD_AUSPOST,
    SYMBOL_2DSWD_IATA25,
    SYMBOL_2DSWD_CODABLOCK,
    SYMBOL_2DSWD_JAPOST,
    SYMBOL_2DSWD_PLANET,
    SYMBOL_2DSWD_DUTCHPOST,
    SYMBOL_2DSWD_MSI,			/* 1D, 2D */
    SYMBOL_2DSWD_TLCODE39,
    SYMBOL_2DSWD_TRIOPTIC,	/* 1D, 2D */
    SYMBOL_2DSWD_CODE32,
    SYMBOL_2DSWD_STRT25,
    SYMBOL_2DSWD_MATRIX25,
    SYMBOL_2DSWD_PLESSEY,
    SYMBOL_2DSWD_CHINAPOST,
    SYMBOL_2DSWD_KOREAPOST,
    SYMBOL_2DSWD_TELEPEN,
    SYMBOL_2DSWD_CODE16K,
    SYMBOL_2DSWD_POSICODE,
    SYMBOL_2DSWD_COUPONCODE,
    SYMBOL_2DSWD_USPS4CB,
    SYMBOL_2DSWD_IDTAG,
    SYMBOL_2DSWD_GS1_128,
    SYMBOL_2DSWD_GEN_CODE128,
    NUM_OF_2DSWD_SYMBOLOGIES
}SYMBOLOGIES_2DSWD;

//---------------------------------------------------------------------
// Supported OCR Fonts
//---------------------------------------------------------------------
typedef enum {
    OCRMODE_DISABLED = 0,
    OCRMODE_A,
    OCRMODE_B,
    OCRMODE_MONEY,
    OCRMODE_MICR_UNSUPPORTED,
} OCRMode;
//---------------------------------------------------------------------
// OCR directions
//---------------------------------------------------------------------
typedef enum {
    OCRDIRECTION_LeftToRight = 0,
    OCRDIRECTION_TopToBottom,
    OCRDIRECTION_RightToLeft,
    OCRDIRECTION_BottomToTop,
} OCRDirection;

#pragma pack(push , 1)
typedef struct{
	BOOL bEnabled;
	WORD nMinLength;
	WORD nMaxLength;
	BOOL bSSXmit;
	BOOL bCheckCharOn;
	BOOL bXmitCheckChar;
}CONFIG_2DSWD_CODABAR;

typedef struct{
	BOOL bEnabled;
	WORD nMinLength;
	WORD nMaxLength;
}CONFIG_2DSWD_AZTEC;

typedef struct{
	BOOL bEnabled;
	WORD nMinLength;
	WORD nMaxLength;
}CONFIG_2DSWD_CODABLOCK;

typedef struct{
	BOOL bEnabled;
	WORD nMinLength;
	WORD nMaxLength;
	BOOL bTwoCheckDigits;
}CONFIG_2DSWD_CODE11;

typedef struct{
	BOOL bEnabled;
	WORD nMinLength;
	WORD nMaxLength;
}CONFIG_2DSWD_CODE128;

typedef struct{
	BOOL bEnabled;
	WORD nMinLength;
	WORD nMaxLength;
}CONFIG_2DSWD_GENERICCODE128;

typedef struct{
	BOOL bEnabled;
	WORD nMinLength;
	WORD nMaxLength;
}CONFIG_2DSWD_GS1128;

typedef struct{
	BOOL bEnabled;
	WORD nMinLength;
	WORD nMaxLength;
	BOOL bSSXmit;
	BOOL bFullAscii;
	BOOL bAppend;
	BOOL bCheckCharOn;
	BOOL bXmitCheckChar;
}CONFIG_2DSWD_CODE39;

typedef struct{
	BOOL bEnabled;
	WORD nMinLength;
	WORD nMaxLength;
}CONFIG_2DSWD_CODE49;

typedef struct{
	BOOL bEnabled;
	WORD nMinLength;
	WORD nMaxLength;
}CONFIG_2DSWD_CODE93;

typedef struct{
	BOOL bEnabled;
	WORD nMinLength;
	WORD nMaxLength;
	BOOL bCompositeOnUpcEan;
}CONFIG_2DSWD_COMPOSITE;

typedef struct{
	BOOL bEnabled;
	WORD nMinLength;
	WORD nMaxLength;
}CONFIG_2DSWD_DATAMATRIX;

typedef struct{
	BOOL bEnabled;
	WORD nMinLength;
	WORD nMaxLength;
}CONFIG_2DSWD_IATA25;

typedef struct{
	BOOL bEnabled;
	WORD nMinLength;
	WORD nMaxLength;
	BOOL bCheckDigitOn;
	BOOL bXmitCheckDigit;
}CONFIG_2DSWD_INT25;

typedef struct{
	BOOL bEnabled;
	WORD nMinLength;
	WORD nMaxLength;
	BOOL bCarrierMsgOnly;
}CONFIG_2DSWD_MAXICODE;

typedef struct{
	BOOL bEnabled;
	WORD nMinLength;
	WORD nMaxLength;
}CONFIG_2DSWD_MICROPDF;

typedef struct{
	BOOL bEnabled;
	WORD nMinLength;
	WORD nMaxLength;
	BOOL bXmitCheckChar;
}CONFIG_2DSWD_MSI;

typedef struct{
	OCRMode nFont;
	TCHAR Template[200];
	TCHAR GroupG[200];
	TCHAR GroupH[200];
	TCHAR CheckChar[200];
	OCRDirection nDirection;
}CONFIG_2DSWD_OCR;

typedef struct{
	BOOL bEnabled;
	WORD nMinLength;
	WORD nMaxLength;
}CONFIG_2DSWD_PDF417;

typedef struct{
	BOOL bEnabled;
	WORD nMinLength;
	WORD nMaxLength;
}CONFIG_2DSWD_QR;

typedef struct{
	BOOL bEnabled;
	WORD nMinLength;
	WORD nMaxLength;
}CONFIG_2DSWD_RSS;

typedef struct{
	BOOL bEnabled;
	WORD nMinLength;
	WORD nMaxLength;
}CONFIG_2DSWD_KOREAPOST;

typedef struct{
	BOOL bEnabled;
	WORD nMinLength;
	WORD nMaxLength;
}CONFIG_2DSWD_CHINAPOST;

typedef struct{
	BOOL bEnabled;
	WORD nMinLength;
	WORD nMaxLength;
}CONFIG_2DSWD_MX25;

typedef struct{
	BOOL bEnabled;
	WORD nMinLength;
	WORD nMaxLength;
}CONFIG_2DSWD_STRT25;

typedef struct{
	BOOL bEnabled;
	WORD nMinLength;
	WORD nMaxLength;
}CONFIG_2DSWD_PLESSEY;

typedef struct{
	BOOL bEnabled;
	WORD nMinLength;
	WORD nMaxLength;
	BOOL bOldStyle;
}CONFIG_2DSWD_TELEPEN;

typedef struct{
	BOOL bEnabled;
	WORD nMinLength;
	WORD nMaxLength;
	WORD wLimited;
}CONFIG_2DSWD_POSICODE;

typedef struct{
	BOOL bEnabled;
	WORD nMinLength;
	WORD nMaxLength;
}CONFIG_2DSWD_CODE16K;
#pragma pack(pop)

typedef struct{
	BOOL bEnabled;
	BOOL bXmitCheckChar;
	BOOL bAddendaReq;
	BOOL bAddendaSeparator;
	BOOL bAddenda2Digit;
	BOOL bAddenda5Digit;
}CONFIG_2DSWD_EAN13;

typedef struct{
	BOOL bEnabled;
	BOOL bXmitCheckChar;
	BOOL bAddendaReq;
	BOOL bAddendaSeparator;
	BOOL bAddenda2Digit;
	BOOL bAddenda5Digit;
}CONFIG_2DSWD_EAN8;

typedef struct{
	BOOL bEnabled;
}CONFIG_2DSWD_ISBT;

typedef struct{
	BOOL bEnabled;
}CONFIG_2DSWD_JAPOST;

typedef struct{
	BOOL bUMSEnabled;
	BOOL bEMSEnabled;
	BOOL b3MSEnabled;
	BOOL b1MSEnabled;
	BOOL bIMSEnabled;
	BOOL b9MSEnabled;
}CONFIG_2DSWD_MESA;

typedef struct{
	BOOL bEnabled;
	BOOL bXmitCheckDigit;
}CONFIG_2DSWD_PLANET;

typedef struct{
	BOOL bEnabled;
	BOOL bXmitCheckDigit;
}CONFIG_2DSWD_POSTNET;

typedef struct{
	BOOL bEnabled;
	BOOL bXmitCheckDigit;
	BOOL bAddendaReq;
	BOOL bAddendaSeparator;
	BOOL bAddenda2Digit;
	BOOL bAddenda5Digit;
	BOOL bXmitNumSys;
}CONFIG_2DSWD_UPCA;

typedef struct{
	BOOL bE0Enabled;
	BOOL bE1Enabled;
	BOOL bXmitCheckDigit;
	BOOL bAddendaReq;
	BOOL bExpandVersionE;
	BOOL bAddendaSeparator;
	BOOL bAddenda2Digit;
	BOOL bAddenda5Digit;
	BOOL bXmitNumSys;
}CONFIG_2DSWD_UPCE;

typedef struct{
	BOOL bEnabled;
}CONFIG_2DSWD_AUSPOST;

typedef struct{
	BOOL bEnabled;
}CONFIG_2DSWD_BPO;

typedef struct{
	BOOL bEnabled;
}CONFIG_2DSWD_CANPOST;

typedef struct{
	BOOL bEnabled;
}CONFIG_2DSWD_DUTCHPOST;

typedef struct{
	BOOL bEnabled;
}CONFIG_2DSWD_COUPONCODE;

typedef struct{
	BOOL bEnabled;
}CONFIG_2DSWD_CODE32;

typedef struct{
	BOOL bEnabled;
}CONFIG_2DSWD_TLC39;

typedef struct{
	BOOL bEnabled;
}CONFIG_2DSWD_TRIOPTIC;

//2012.12.04 yjcho
typedef struct{
	BOOL bEnabled;
}CONFIG_2DSWD_USPS4CB;
// 2012.12.04 yjcho
typedef struct{
	BOOL bEnabled;
}CONFIG_2DSWD_IDTAG;

#endif

















