#ifndef __CBLUETOOTH__API__H__
#define __CBLUETOOTH__API__H__

#define CBluetoothApi_API extern "C" __declspec(dllexport)

#define WM_BT_RESPONSE			WM_USER + 1802

typedef enum
{
	BT_RESULT_SUCCESS			= 0,
	BT_RESULT_INVALID_ARGS,
	BT_RESULT_OUTOFMEMORY,
	BT_RESULT_UNSUPPORTED,
	BT_RESULT_ALREADY_OPENED,
	BT_RESULT_NOT_OPENED,
	BT_RESULT_FAILURE,
	BT_RESULT_INVALID_DEVICE
}BT_RESULT;

typedef enum
{
	BTCALLBACKTYPE_SCANED_DATA = 0,
	BTCALLBACKTYPE_INFO_DATA,
	BTCALLBACKTYPE_REPLY
}BTCALLBACKTYPE;

typedef struct
{
	BTCALLBACKTYPE CallbackType;
	TCHAR szData[MAX_PATH];
}BTCALLBACKDATA;

typedef void (CALLBACK* BTCALLBACK)(BTCALLBACKDATA* pBtCallbackData);

#define BT_MODE_STANDARD			'0'	// Mode0 accepts all AT command supported
#define BT_MODE_MASTER				'1' // Mode1 try to connect peer device
#define BT_MODE_SLAVE				'2' // Mode2 waiting for connection
#define BT_MODE_ALWAYS_CONNECTABLE	'3' // Mode3 always connectable 

CBluetoothApi_API BT_RESULT BtDropFromOnline();						// OK
CBluetoothApi_API BT_RESULT BtReturnToOnline();						// OK
CBluetoothApi_API BT_RESULT BtOpen(int BaudNum);
CBluetoothApi_API BT_RESULT BtClose();
CBluetoothApi_API BT_RESULT BtHardReset();							// OK
CBluetoothApi_API BT_RESULT BtSoftReset();							// OK
CBluetoothApi_API BT_RESULT BtScanDevice();							// OK
CBluetoothApi_API BT_RESULT BtStop();								// OK
CBluetoothApi_API BT_RESULT BtConnect(LPWSTR szAddress);			// CONNECTED
CBluetoothApi_API BT_RESULT BtDisconnect();							// DISCONNECTED
CBluetoothApi_API BT_RESULT BtModeSave(char Mode);					// OK
CBluetoothApi_API BT_RESULT BtGetInformation();	// OK
CBluetoothApi_API BT_RESULT BtInputPincode(LPWSTR szPinCode);		// OK
CBluetoothApi_API BT_RESULT BtBaudChange(int BaudRate);
CBluetoothApi_API BT_RESULT BtPowerEnable(BOOL bEnable);
CBluetoothApi_API BT_RESULT BtGetPowerStatus(BOOL* pbEnabled);
CBluetoothApi_API BT_RESULT BtSetHwnd(HWND hWnd);
CBluetoothApi_API BT_RESULT BtSetCallback(BTCALLBACK pFunc);
CBluetoothApi_API BT_RESULT BtSetDeviceName(LPWSTR szDeviceName);
CBluetoothApi_API BT_RESULT BtTestPrint();

#endif