#ifndef __CFINGERPRINT__API__H__
#define __CFINGERPRINT__API__H__

#define CFingerPrintApi_API extern "C" __declspec(dllexport)

#define FPR_CMD_REGISTRATION	1
#define FPR_CMD_AUTHENTICATION	2

typedef enum
{
	FPR_RESULT_SUCCESS			= 0,
	FPR_RESULT_INVALID_ARGS,
	FPR_RESULT_OUTOFMEMORY,
	FPR_RESULT_UNSUPPORTED,
	FPR_RESULT_ALREADY_OPENED,
	FPR_RESULT_NOT_OPENED,
	FPR_RESULT_COMMAND_FAILURE,
	FPR_RESULT_REGIST_FAILURE,
	FPR_RESULT_DEREGIST_FAILURE,
	FPR_RESULT_NOT_EXIST_ID,
	FPR_RESULT_AUTH_FAILURE,
	FPR_RESULT_STATUS_IS_NOT_IDLE,
	FPR_RESULT_INVALID_DEVICE,
	FPR_RESULT_FAILURE
}FPR_RESULT;

CFingerPrintApi_API FPR_RESULT FingerPrintOpen();
CFingerPrintApi_API FPR_RESULT FingerPrintClose();
CFingerPrintApi_API FPR_RESULT FingerPrintStartRegistration(UCHAR ID);
CFingerPrintApi_API FPR_RESULT FingerPrintDeRegister(UCHAR ID);
CFingerPrintApi_API FPR_RESULT FingerPrintStartAuthentication();
CFingerPrintApi_API FPR_RESULT FingerPrintGetIdCount(UCHAR* pIdCount);
CFingerPrintApi_API FPR_RESULT FingerPrintCancel();
CFingerPrintApi_API FPR_RESULT FingerPrintReadResult(UCHAR Command, UCHAR* pID);
CFingerPrintApi_API FPR_RESULT FingerPrintGetFirmwareVersion(UCHAR* pVersion);

#endif