#ifndef __CGPS__API__H__
#define __CGPS__API__H__

#define CGpsApi_API extern "C" __declspec(dllexport)

typedef void (CALLBACK* GPSMGSCALLBACK)(LPWSTR szGpsData);
typedef void (CALLBACK* GPSRAWDATACALLBACK)(BYTE* pBuff, int len);

#define WM_GPS_ONRECEIVED			WM_USER + 1803
#define WM_GPS_ONRECEIVED_RAWDATA	WM_GPS_ONRECEIVED + 30

typedef enum _gps_portnum
{
        COM1 = 1,
        COM2,
        COM3,
        COM4,
        COM5,
        COM6,
        COM7,
        COM8,
        COM9,
        COM10
}PORT;

typedef enum
{
	GPS_RESULT_SUCCESS = 0,
	GPS_RESULT_INVALID_ARGS,
	GPS_RESULT_OUTOFMEMORY,
	GPS_RESULT_UNSUPPORTED,
	GPS_RESULT_ALREADY_OPENED,
	GPS_RESULT_NOT_OPENED,
	GPS_RESULT_FAILURE,
	GPS_RESULT_INVALID_DEVICE
}GPS_RESULT;

CGpsApi_API GPS_RESULT	GpsOpen(PORT GPS_Port, unsigned int GPS_Baud);
CGpsApi_API GPS_RESULT	GpsClose();
CGpsApi_API BOOL	GpsIsOpen();
CGpsApi_API void	GpsSetHwnd(HWND hWnd);
CGpsApi_API GPS_RESULT	GpsSetCallbackFunc(GPSMGSCALLBACK pFunc);
CGpsApi_API GPS_RESULT	GpsTxData(UCHAR * pcmd, int len);

CGpsApi_API void	GpsSetRawDataHwnd(HWND hWnd);
CGpsApi_API GPS_RESULT	GpsSetRawDataCallbackFunc(GPSRAWDATACALLBACK pFunc);

#endif