#ifndef __CMSR__API__H__
#define __CMSR__API__H__

#define CMsrApi_API extern "C" __declspec(dllexport)
#define MAX_TRACK_BUFFER	107

typedef enum{
	TRACK1_INDEX = 0,
	TRACK2_INDEX,
	TRACK3_INDEX,
	JIS_INDEX,
	TRACK_TOTAL_CNT
}TRACK_CNT;

typedef enum
{
	MSR_RESULT_SUCCESS			= 0,
	MSR_RESULT_INVALID_ARGS,
	MSR_RESULT_OUTOFMEMORY,
	MSR_RESULT_UNSUPPORTED,
	MSR_RESULT_ALREADY_OPENED,
	MSR_RESULT_NOT_OPENED,
	MSR_RESULT_FAILURE,
	MSR_RESULT_BUSY,
	MSR_RESULT_TIME_OUT,
	MSR_RESULT_CANCELLED,
	MSR_RESULT_WAITING_END_OF_PRINTING,
	MSR_RESULT_RECEIVED_END_OF_PRINTING,
	MSR_RESULT_INVALID_DEVICE
}MSR_RESULT;

#define WM_MSR_RESPONSE		WM_USER + 1807

typedef void (CALLBACK* MSRCALLBACK)(MSR_RESULT MsrResult);

CMsrApi_API MSR_RESULT	MsrOpen();
CMsrApi_API MSR_RESULT	MsrClose();
CMsrApi_API BOOL		MsrIsOpened();
CMsrApi_API void		MsrSetHwnd(HWND hWnd);
CMsrApi_API MSR_RESULT	MsrSetCallback(MSRCALLBACK Callback);
CMsrApi_API MSR_RESULT	MsrStartReadCard();
CMsrApi_API MSR_RESULT	MsrCancelReadCard();
CMsrApi_API MSR_RESULT	MsrGetData(LPWSTR szTrack1, LPWSTR szTrack2, LPWSTR szTrack3, LPWSTR szJIS);
CMsrApi_API MSR_RESULT	MsrGetFirmwareVersion(LPWSTR szVersion);


#endif