#ifndef __CRFID1356__API__H__
#define __CRFID1356__API__H__

#define CRfid1356Api_API extern "C" __declspec(dllexport)


typedef enum
{
	HF_RESULT_SUCCESS = 0,
	HF_RESULT_INVALID_ARGS,
	HF_RESULT_OUTOFMEMORY,
	HF_RESULT_UNSUPPORTED,
	HF_RESULT_ALREADY_OPENED,
	HF_RESULT_NOT_OPENED,
	HF_RESULT_FAILURE,
	HF_RESULT_INVALID_DEVICE
}HF_RESULT;


CRfid1356Api_API HF_RESULT Rfid1356Open();
CRfid1356Api_API HF_RESULT Rfid1356Close();
CRfid1356Api_API BOOL	Rfid1356IsOpen();
CRfid1356Api_API HF_RESULT Rfid1356AntennaOff();
CRfid1356Api_API HF_RESULT	Rfid1356ReadFirmwareVersion(LPWSTR szVersion);

// Mifare
CRfid1356Api_API HF_RESULT Rfid1356MifareReadUid(LPWSTR szUID);
CRfid1356Api_API HF_RESULT Rfid1356MifareReadBlock(LPWSTR szBlock, LPWSTR szKeyType, LPWSTR szKeySet, LPWSTR szReadData);
CRfid1356Api_API HF_RESULT Rfid1356MifareWriteBlock(LPWSTR szBlock, LPWSTR szKeyType, LPWSTR szKeySet, LPWSTR szWriteData);
CRfid1356Api_API HF_RESULT Rfid1356MifareKeyLoad(LPWSTR szBlock, LPWSTR szKeyType, LPWSTR szKeySet, LPWSTR szKey);
CRfid1356Api_API HF_RESULT Rfid1356MifareIncrement(LPWSTR szBlock, LPWSTR szKeyType, LPWSTR szKeySet, uint nValue);
CRfid1356Api_API HF_RESULT Rfid1356MifareDecrement(LPWSTR szBlock, LPWSTR szKeyType, LPWSTR szKeySet, uint nValue);
CRfid1356Api_API HF_RESULT Rfid1356Iso14443APDU(LPWSTR szSendData, LPWSTR szResultData);
CRfid1356Api_API HF_RESULT Rfid1356Iso14443APDU_Hx(LPWSTR szSendData, LPWSTR szResultData);
// Mifare Ultra Light
CRfid1356Api_API HF_RESULT Rfid1356MifareUltraReadBlock(LPWSTR szTagNum, LPWSTR szBlock, LPWSTR szReadNum, LPWSTR szReadData);
CRfid1356Api_API HF_RESULT Rfid1356MifareUltraWriteBlock(LPWSTR szTagNum, LPWSTR szBlock, LPWSTR szWriteData);
CRfid1356Api_API HF_RESULT Rfid1356GetAppendCardType(BOOL* pEnable);
CRfid1356Api_API HF_RESULT Rfid1356SetAppendCardType(BOOL Enable);

// ISO15693
CRfid1356Api_API HF_RESULT Rfid1356Iso15693ReadUid(LPWSTR szUID);
CRfid1356Api_API HF_RESULT Rfid1356Iso15693ReadBlock(LPWSTR szBlock, LPWSTR szReadCount, LPWSTR szReadData);
CRfid1356Api_API HF_RESULT Rfid1356Iso15693WriteBlock(LPWSTR szBlock, LPWSTR szWriteData);
CRfid1356Api_API HF_RESULT Rfid1356Iso15693LockBlock(LPWSTR szBlock);
CRfid1356Api_API HF_RESULT Rfid1356Iso15693ReadAfi(LPWSTR szData, LPWSTR szAFI);
CRfid1356Api_API HF_RESULT Rfid1356Iso15693WriteAfi(LPWSTR szAFI);
CRfid1356Api_API HF_RESULT Rfid1356Iso15693LockAfi();
CRfid1356Api_API HF_RESULT Rfid1356Iso15693WriteDsfid(LPWSTR szDSFID);
CRfid1356Api_API HF_RESULT Rfid1356Iso15693LockDsfid();


#endif