#ifndef __CRFID__API__H__
#define __CRFID__API__H__

//#include "ATRMUHF.h"

#define CRfidApi_API extern "C" __declspec(dllexport)

#define WM_RFID_RESPONSE			WM_USER + 1804

#define MAX_MASK_BYTES	(256/8)
#define MAX_SELECT_MASK	8

#define MODULE_TYPE_NONE	0x30
#define MODULE_TYPE_H1000	0x31
#define MODULE_TYPE_I2000	0x32
#define MODULE_TYPE_I900	0x33

#define EURO_MODE_HOP	0x1
#define EURO_MODE_FIX	0x2

typedef enum
{
	RFIDCALLBACKTYPE_DATA = 0,
	RFIDCALLBACKTYPE_REPLY
}RFIDCALLBACKTYPE;

typedef struct
{
	//UINT iMessage;
	RFIDCALLBACKTYPE CallbackType;
	WPARAM wParam;
	LPARAM lParam;
}RFIDCALLBACKDATA;

typedef enum{
	RFID_REPORT_MODE_WAIT_DONE				= 1,
	RFID_REPORT_MODE_ACCESS_EPC			= 2,
	RFID_REPORT_MODE_EXTENDED_INFORMATION	= 4
}RFIDREPORTMODE;

typedef enum{
	RFIDCTRL_ALL				= 0x61,
	RFIDCTRL_CONTINUE		= 0x63,
	RFIDCTRL_DEFAULT			= 0x64,
	RFIDCTRL_LBT_TIME		= 0x67,
	RFIDCTRL_CH_NUMBER		= 0x6e,
	RFIDCTRL_HOPPING_ONOFF	= 0x6f,
	RFIDCTRL_POWER			= 0x70,
	RFIDCTRL_QVALUE			= 0x71,
	RFIDCTRL_LBT_CH_STATE	= 0x72,
	RFIDCTRL_SESSION			= 0x73,
	RFIDCTRL_SCANTIME		= 0x74,
	RFIDCTRL_VERSION			= 0x76
}RFIDCTRL;


typedef enum{
	RFID_SESSIONTYPE_0	= 0x30,
	RFID_SESSIONTYPE_1	= 0x31,
	RFID_SESSIONTYPE_2	= 0x32,
	RFID_SESSIONTYPE_3	= 0x33
}RFIDSESSIONTYPE;

typedef enum{
	RFID_HOPPINGMODE_HOP_ANONYMOUS	= 0,
	RFID_HOPPINGMODE_KOREA_FHSS		= 0x30,
	RFID_HOPPINGMODE_KOREA_LBT		= 0x31,
	RFID_HOPPINGMODE_JAPAN_LBT		= 0x32,
	RFID_HOPPINGMODE_EURO_LBT		= 0x33,
	RFID_HOPPINGMODE_USA_FHSS		= 0x34,
	RFID_HOPPINGMODE_CHINA_FHSS		= 0x36,
	RFID_HOPPINGMODE_JAPAN_NO_LBT	= 0x37,
	RFID_HOPPINGMODE_KOREA_KCCh		= 0x38,
	RFID_HOPPINGMODE_ETSI			= 0x39,
	RFID_HOPPINGMODE_ETSI_B3		= 0x3A
}RFIDHOPPINGMODE;

typedef enum{
	RFID_BANDCODE_ANONYMOUS	= 0,
	RFID_BANDCODE_FCC		= 1,
	RFID_BANDCODE_KMIC,
	RFID_BANDCODE_ARIB,
	RFID_BANDCODE_ETSI1,
	RFID_BANDCODE_ETSI2,
	RFID_BANDCODE_ARIBs,
	RFID_BANDCODE_CHINA,
	RFID_BANDCODE_ARIBh
}RFIDBANDCODE;

typedef enum{
	RFID_INVENTORIEDSTATE_A	= 0x30,
	RFID_INVENTORIEDSTATE_B	= 0x31,
	RFID_INVENTORIEDSTATE_AB	= 0x32
}RFIDINVENTORIEDSTATE;

typedef enum {
	RFID_ISO_180006B_ONE_TAG	= 0x61,
	RFID_ISO_180006B_MULTI_TAG 	= 0x62,
	RFID_EPC_GEN2_ONE_TAG	= 0x65,
	RFID_EPC_GEN2_MULTI_TAG	= 0x66
}RFIDREAD_TYPE;


typedef enum {
	RFID_PERMALOCK_FIELD_KILL_PASSWORD 		= 0x01,
	RFID_PERMALOCK_FIELD_ACCESS_PASSWORD 	= 0x02,
	RFID_PERMALOCK_FIELD_EPC 			= 0x03,
	RFID_PERMALOCK_FIELD_TID 			= 0x04,
	RFID_PERMALOCK_FIELD_USER 			= 0x05,
}RFIDPERMALOCK_FIELD;

typedef enum {
	RFID_EXTENDED_INFORMATION_RSSI	= 0x01,
	RFID_EXTENDED_INFORMATION_PHASE	= 0x02,
	RFID_EXTENDED_INFORMATION_FREQUENCY	= 0x04,
}EXTENDED_INFORMATION;

typedef struct {
	bool bKillPassword;
	bool bAccessPassword;
	bool bEPC;
	bool bTID;
	bool bUSER;
}RFIDLOCK_UNLOCK_FIELD, *RFIDPLOCK_UNLOCK_FIELD;

typedef struct {
	BYTE MemBank;
	UINT nOffSet;
	LPWSTR szMaskPattern;
}RFIDMASK_PARAMS, *RFIDPMASK_PARAMS;


typedef struct{
	BYTE MemBank;
	UINT nOffSet;
	UINT nBits;
	BYTE byMaskPattern[MAX_MASK_BYTES];
}RFIDMASK_PARAMS_EX, *RFIDPMASK_PARAMS_EX;



typedef struct{
	BYTE SelectTarget;	// select target, 0=s0,1=s1,2=s2,3=s3,4=select flag
	BYTE ActionCode;    // select action, 
					//+-------+----------------------------+---------------------------+
					//|       | SelectTarget==SL           | SelectTarget==Inventoried |
					//|Action +----------------------------+-----------+---------------+
					//| Code  | matching    | non-matching | matching  | non-matching  |
					//+-------+-------------+--------------+-----------+---------------+
					//| 0     | Assert SL   | De-assert SL | ->A       | ->B           |
					//| 1     | Assert SL   | No Action    | ->A       | No Action     |
					//| 2     | No Action   | De-assert SL | No Action | ->B           |
					//| 3     | Negate SL   | No Action    | Negate    | No Action     |
					//| 4     | De-assert SL| Assert SL    | ->B       | ->A           |
					//| 5     | De-assert SL| No Action    | ->B       | No Action     |
					//| 6     | No Action   | Assert SL    | No Action | ->A           |
					//| 7     | No Action   | Negate SL    | No Action | Negate        |
					//+-------+-------------+--------------+-----------+---------------+
	BYTE mskMemBank;	// mem bank id for selection mask. it is one of the BANK_RESERVED,BANK_EPC,BANK_TID and BANK_USER.
	UINT mskOffset;		// mem bank bit offset for selection mask
	UINT mskBits;		// mem bank pattern bits for selection mask
	BYTE mskPattern[MAX_MASK_BYTES];// bit pattern for selection mask
}RFID_MASK_PARAMS_EX2, *PRFID_MASK_PARAMS_EX2;

typedef enum {
	RFID_MEM_BANK_RESERVED	= 0x30,
	RFID_MEM_BANK_EPC		= 0x31,
	RFID_MEM_BANK_TID		= 0x32,
	RFID_MEM_BANK_USER		= 0x33
}RFIDMEM_BANK;

typedef struct{
	UINT nModeOn;
	UINT nModeOff;
}RFIDREPORTMODEPARAMS;

typedef struct{
	RFIDCTRL CtrlCode;
	LPWSTR szCtrlValue;
}RFIDCTRLPARAMS;

typedef struct{
	UINT nOnMs;
	UINT nOffMs;
}RFIDAIRDURAPARAMS;

typedef enum
{
	RFID_RESULT_SUCCESS			= 0,
	RFID_RESULT_OUTOFMEMORY,
	RFID_RESULT_INVALID_ARGS,
	RFID_RESULT_UNEXPECTED,
	RFID_RESULT_FAILURE,
	RFID_RESULT_ALREADY_OPENED,
	RFID_RESULT_INVALID_DEVICE,
	RFID_RESULT_NOT_CONNECTED,
	RFID_RESULT_NOT_DETECT,
	RFID_RESULT_ACCESS_ERROR,
	RFID_RESULT_NOT_OPENED,
	RFID_RESULT_COMMAND_ERROR,
	RFID_RESULT_LOW_BATTERY,
	RFID_RESULT_UNKNOWN,
	RFID_RESULT_NOT_SUPPORTED,
	RFID_RESULT_STOPPED,
	RFID_RESULT_POWER_OFF,
}RFID_RESULT;

typedef void (CALLBACK* RFIDCALLBACK)(RFIDCALLBACKDATA* pCallbackData);

CRfidApi_API RFID_RESULT	RfidPowerOn();
CRfidApi_API void			RfidPowerOff();
CRfidApi_API RFID_RESULT	RfidOpen();
CRfidApi_API BOOL			RfidIsOpen();
CRfidApi_API void			RfidClose();
CRfidApi_API RFID_RESULT	RfidStop();
CRfidApi_API RFID_RESULT	RfidSetHwnd(HWND hWnd);
CRfidApi_API RFID_RESULT	RfidSetCallback(RFIDCALLBACK pCallback);

//CRfidApi_API RFID_RESULT RfidSetSelectActionMultiple(int nCount, PRFID_SELECT_MASK_EX pSelectMask);

CRfidApi_API RFID_RESULT RfidReadEPC(BOOL bSyncMode, RFIDREAD_TYPE ReadType, RFIDPMASK_PARAMS pMask, LPWSTR szEpcData);
CRfidApi_API RFID_RESULT RfidReadMemBank(BOOL bSyncMode, RFIDMEM_BANK MemBank, UINT nWordPtr, UINT nWordCount, BOOL bContinuous, LPWSTR szAccessPassword, RFIDPMASK_PARAMS pMask, LPWSTR szMemBankData);
CRfidApi_API RFID_RESULT RfidWriteMemBank(BOOL bSyncMode, RFIDMEM_BANK MemBank, UINT nWordPtr, LPWSTR szData, BOOL bContinuous, LPWSTR szAccessPassword, RFIDPMASK_PARAMS pMask);
CRfidApi_API RFID_RESULT RfidLockField(BOOL bSyncMode, RFIDPLOCK_UNLOCK_FIELD pLockField, BOOL bContinuous, LPWSTR szAccessPassword, RFIDPMASK_PARAMS pMask);
CRfidApi_API RFID_RESULT RfidUnLockField(BOOL bSyncMode, RFIDPLOCK_UNLOCK_FIELD pLockField, BOOL bContinuous, LPWSTR szAccessPassword, RFIDPMASK_PARAMS pMask);
CRfidApi_API RFID_RESULT RfidPermalock(BOOL bSyncMode, RFIDPERMALOCK_FIELD PermalockField, BOOL bSecured, BOOL bContinuous, LPWSTR szAccessPassword, RFIDPMASK_PARAMS pMask);
CRfidApi_API RFID_RESULT RfidKillTag(BOOL bSyncMode, LPWSTR szKillPassword, BOOL bContinuous, RFIDPMASK_PARAMS pMask);
CRfidApi_API RFID_RESULT RfidGetResult(LPWSTR szResult, RFIDCALLBACKTYPE CallbackType, WPARAM wParam, LPARAM lParam);
CRfidApi_API RFID_RESULT RfidGetAccessedEPC(LPWSTR szEPC);

CRfidApi_API RFID_RESULT RfidReadEPCEx(BOOL bSyncMode, RFIDREAD_TYPE ReadType, RFIDPMASK_PARAMS_EX pMask, LPWSTR szEpcData);
CRfidApi_API RFID_RESULT RfidReadMemBankEx(BOOL bSyncMode, RFIDMEM_BANK MemBank, UINT nWordPtr, UINT nWordCount, BOOL bContinuous, LPWSTR szAccessPassword, RFIDPMASK_PARAMS_EX pMask, LPWSTR szMemBankData);
CRfidApi_API RFID_RESULT RfidWriteMemBankEx(BOOL bSyncMode, RFIDMEM_BANK MemBank, UINT nWordPtr, LPWSTR szData, BOOL bContinuous, LPWSTR szAccessPassword, RFIDPMASK_PARAMS_EX pMask);
CRfidApi_API RFID_RESULT RfidLockFieldEx(BOOL bSyncMode, RFIDPLOCK_UNLOCK_FIELD pLockField, BOOL bContinuous, LPWSTR szAccessPassword, RFIDPMASK_PARAMS_EX pMask);
CRfidApi_API RFID_RESULT RfidUnLockFieldEx(BOOL bSyncMode, RFIDPLOCK_UNLOCK_FIELD pLockField, BOOL bContinuous, LPWSTR szAccessPassword, RFIDPMASK_PARAMS_EX pMask);
CRfidApi_API RFID_RESULT RfidPermalockEx(BOOL bSyncMode, RFIDPERMALOCK_FIELD PermalockField, BOOL bSecured, BOOL bContinuous, LPWSTR szAccessPassword, RFIDPMASK_PARAMS_EX pMask);
CRfidApi_API RFID_RESULT RfidKillTagEx(BOOL bSyncMode, LPWSTR szKillPassword, BOOL bContinuous, RFIDPMASK_PARAMS_EX pMask);

CRfidApi_API int RfidGetSelects();
CRfidApi_API RFID_RESULT RfidSetSelects(UINT nNumberOfSelect);
CRfidApi_API RFID_RESULT RfidReadEPCEx2(BOOL bSyncMode, RFIDREAD_TYPE ReadType, PRFID_MASK_PARAMS_EX2 pMasks, UINT nNumberOfMasks, LPWSTR szEpcData);
CRfidApi_API RFID_RESULT RfidReadMemBankEx2(BOOL bSyncMode, RFIDMEM_BANK MemBank, UINT nWordPtr, UINT nWordCount, BOOL bContinuous, LPWSTR szAccessPassword, PRFID_MASK_PARAMS_EX2 pMasks, UINT nNumberOfMasks, LPWSTR szMemBankData);
CRfidApi_API RFID_RESULT RfidReadMemBankEx2(BOOL bSyncMode, RFIDMEM_BANK MemBank, UINT nWordPtr, UINT nWordCount, BOOL bContinuous, LPWSTR szAccessPassword, PRFID_MASK_PARAMS_EX2 pMasks, UINT nNumberOfMasks, LPWSTR szMemBankData);
CRfidApi_API RFID_RESULT Rfid900SysWriteMemBankEx2(BOOL bSyncMode, RFIDMEM_BANK MemBank, UINT nWordPtr, LPWSTR szData, BOOL bContinuous, LPWSTR szAccessPassword, PRFID_MASK_PARAMS_EX2 pMasks, UINT nNumberOfMasks);
CRfidApi_API RFID_RESULT Rfid900SysLockFieldEx2(BOOL bSyncMode, RFIDPLOCK_UNLOCK_FIELD pLockField, BOOL bContinuous, LPWSTR szAccessPassword, PRFID_MASK_PARAMS_EX2 pMasks, UINT nNumberOfMasks);
CRfidApi_API RFID_RESULT Rfid900SysUnLockFieldEx2(BOOL bSyncMode, RFIDPLOCK_UNLOCK_FIELD pLockField, BOOL bContinuous, LPWSTR szAccessPassword, PRFID_MASK_PARAMS_EX2 pMasks, UINT nNumberOfMasks);
CRfidApi_API RFID_RESULT Rfid900SysPermalockEx2(BOOL bSyncMode, RFIDPERMALOCK_FIELD PermalockField, BOOL bSecured, BOOL bContinuous, LPWSTR szAccessPassword, PRFID_MASK_PARAMS_EX2 pMasks, UINT nNumberOfMasks);
CRfidApi_API RFID_RESULT Rfid900SysKillTagEx2(BOOL bSyncMode, LPWSTR szKillPassword, BOOL bContinuous, PRFID_MASK_PARAMS_EX2 pMasks, UINT nNumberOfMasks);

CRfidApi_API RFID_RESULT RfidSetReportMode(RFIDREPORTMODEPARAMS* pRfidParams);
CRfidApi_API RFID_RESULT RfidGetAccessedEpc(LPWSTR szAccessEpc);
CRfidApi_API LPWSTR	RfidGetLastError();
CRfidApi_API RFID_RESULT RfidSetDefault();
CRfidApi_API RFID_RESULT RfidSetExtInfoEnable(BOOL bEnable);
CRfidApi_API RFID_RESULT RfidSetExtInfoEnableEx(BYTE nInfo, BOOL bEnable);
CRfidApi_API RFID_RESULT RfidGetQValue(UINT* pnQvalue);
CRfidApi_API RFID_RESULT RfidSetQValue(UINT nQvalue);
CRfidApi_API RFID_RESULT RfidGetOperationTime(UINT* pnOperationTime);
CRfidApi_API RFID_RESULT RfidSetOperationTime(UINT nOperationTime);
CRfidApi_API RFID_RESULT RfidGetPowerLevel(UINT* pnPowerLevel);
CRfidApi_API RFID_RESULT RfidSetPowerLevel(UINT nPowerLevel);
CRfidApi_API RFID_RESULT RfidGetSession(RFIDSESSIONTYPE* pSessionType);
CRfidApi_API RFID_RESULT RfidSetSession(RFIDSESSIONTYPE SessionType);
CRfidApi_API RFID_RESULT RfidSetInventoryTarget(RFIDINVENTORIEDSTATE InventoriedState);
CRfidApi_API RFID_RESULT RfidGetInventoryTarget(RFIDINVENTORIEDSTATE* pInventoriedState); //0224
CRfidApi_API RFID_RESULT RfidGetLbtChState(UINT* pnLbtChState);
CRfidApi_API RFID_RESULT RfidSetLbtChState(UINT nLbtChState);
CRfidApi_API RFID_RESULT RfidGetChannelState(UINT* pnChState);
CRfidApi_API RFID_RESULT RfidSetChannelState(UINT nChState);
CRfidApi_API RFID_RESULT RfidGetLbtTime(UINT* pnLbtTime);
CRfidApi_API RFID_RESULT RfidSetLbtTime(UINT nLbtTime);
CRfidApi_API RFID_RESULT RfidSetAirDura(RFIDAIRDURAPARAMS* pRfidParams);
CRfidApi_API RFID_RESULT RfidSetAirDuty(UINT nSpeed);
CRfidApi_API RFID_RESULT RfidGetFirmwareVersion(LPWSTR szVersion);
CRfidApi_API RFID_RESULT RfidGetControlValue(RFIDCTRLPARAMS* pRfidParams);
CRfidApi_API RFID_RESULT RfidGetHoppingMode(RFIDHOPPINGMODE* pHoppingMode);
CRfidApi_API RFID_RESULT RfidSetHoppingMode(RFIDHOPPINGMODE HoppingMode);
CRfidApi_API RFID_RESULT RfidSetHoppingEnable(BOOL bEnable);
CRfidApi_API RFID_RESULT RfidSetChNumber(UINT nChNumber);
CRfidApi_API RFID_RESULT RfidSetBand(RFIDBANDCODE BandCode);
CRfidApi_API RFID_RESULT RfidGetXcvrMaxPwr(UINT* pPwr); //0224
CRfidApi_API RFID_RESULT RfidGetOemId(LPWSTR szID);
CRfidApi_API uint RfidGetModuleType();
CRfidApi_API RFID_RESULT RfidCWEnable(BOOL bEnable);
CRfidApi_API RFID_RESULT RfidGetLinkProfile(BYTE * pvalue);
CRfidApi_API RFID_RESULT RfidSetLinkProfile(BYTE value);

CRfidApi_API BOOL RfidIsRunning();
CRfidApi_API RFID_RESULT RfidStopEx(BOOL block);

CRfidApi_API BOOL RfidGetR1000MacReg(unsigned short Reg, unsigned int * pValue);
CRfidApi_API BOOL RfidSetR1000MacReg(unsigned short Reg, unsigned int Value);

CRfidApi_API BOOL RfidGetR1000Reg(int Bank, unsigned short Reg, unsigned int * pValue);
CRfidApi_API BOOL RfidSetR1000Reg(int Bank, unsigned short Reg, unsigned int Value);

CRfidApi_API BOOL RfidGetEuroMode(unsigned int * pmode);
CRfidApi_API BOOL RfidSetEuroMode(unsigned int mode);

CRfidApi_API RFID_RESULT RfidSetTagFocus(BOOL bEnable);
CRfidApi_API RFID_RESULT RfidGetTagFocusStatus(BOOL* pbEnable);

CRfidApi_API RFID_RESULT RfidAlienBlockReadLock(BOOL bSyncMode, RFIDMEM_BANK MemBank, BYTE LockMask, BOOL bContinuous, LPWSTR szAccessPassword, RFIDPMASK_PARAMS pMask);
CRfidApi_API RFID_RESULT RfidAlienBlockReadLockEx(BOOL bSyncMode, RFIDMEM_BANK MemBank, BYTE LockMask, BOOL bContinuous, LPWSTR szAccessPassword, RFIDPMASK_PARAMS_EX pMask);
CRfidApi_API RFID_RESULT RfidAlienBlockReadLockEx2(BOOL bSyncMode, RFIDMEM_BANK MemBank, BYTE LockMask, BOOL bContinuous, LPWSTR szAccessPassword, PRFID_MASK_PARAMS_EX2 pSelectMasks, UINT nNumberOfMasks);


CRfidApi_API RFID_RESULT RfidBlockPermalock(BOOL bSyncMode, UINT nReadLock, RFIDMEM_BANK MemBank, UINT nBlockPtr, UINT16 nBlockMask, BOOL bContinuous, LPWSTR szAccessPassword, RFIDPMASK_PARAMS pMask);
CRfidApi_API RFID_RESULT RfidBlockPermalockEx(BOOL bSyncMode, UINT nReadLock, RFIDMEM_BANK MemBank, UINT nBlockPtr, UINT16 nBlockMask, BOOL bContinuous, LPWSTR szAccessPassword, RFIDPMASK_PARAMS_EX pMask);
CRfidApi_API RFID_RESULT RfidBlockPermalockEx2(BOOL bSyncMode, UINT nReadLock, RFIDMEM_BANK MemBank, UINT nBlockPtr, UINT16 nBlockMask, BOOL bContinuous, LPWSTR szAccessPassword, PRFID_MASK_PARAMS_EX2 pSelectMasks, UINT nNumberOfMasks);
CRfidApi_API RFID_RESULT RfidBlockPermalockEx3(BOOL bSyncMode, UINT nReadLock, RFIDMEM_BANK MemBank, UINT nBlockPtr, BYTE nBlockRange, UINT16* pnBlockMask, BOOL bContinuous, LPWSTR szAccessPassword, RFIDPMASK_PARAMS pMask);
CRfidApi_API RFID_RESULT RfidBlockPermalockEx4(BOOL bSyncMode, UINT nReadLock, RFIDMEM_BANK MemBank, UINT nBlockPtr, BYTE nBlockRange, UINT16* pnBlockMask, BOOL bContinuous, LPWSTR szAccessPassword, RFIDPMASK_PARAMS_EX pMask);
CRfidApi_API RFID_RESULT RfidBlockPermalockEx5(BOOL bSyncMode, UINT nReadLock, RFIDMEM_BANK MemBank, UINT nBlockPtr, BYTE nBlockRange, UINT16* pnBlockMask, BOOL bContinuous, LPWSTR szAccessPassword, PRFID_MASK_PARAMS_EX2 pSelectMasks, UINT nNumberOfMasks);

CRfidApi_API BOOL RfidGetR2000Reg(int Bank, unsigned short Reg, unsigned int * pValue);
CRfidApi_API BOOL RfidSetR2000Reg(int Bank, unsigned short Reg, unsigned int Value);

#endif