﻿Imports Barcode_VB._Native
Imports NBarcodeApi
Imports NSysSvcApi
Imports System.Threading

Public Class Form1

    Public specifiedKeys As ArrayList = Nothing
    Public is2DScanner As Boolean = False
    Public Const title As String = "Barcode Example"
    Public Shared sysSvc As NSysSvcApi.SysSvcApi = Nothing
    Public barcode As BarcodeApi = Nothing


    Private Sub Form1_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load
        System.Diagnostics.Debug.WriteLine(">>> Form1_Load Start ")
        ' InitializeComponent()

        Me.Text = title
        If (Utils.IsWinCE = True) Then
            Me.Menu = Nothing
            listView1.Location = New Point(0, 0)
        End If
        'create system service object
        sysSvc = New SysSvcApi()
        Dim hwOptions As HW_OPTIONS = New HW_OPTIONS()
        'Check what type of scanner
        sysSvc.GetHardwareOptions(hwOptions)
        If (hwOptions.Barcode = HW_TYPE_BARCODE.NONE) Then
            sysSvc.Dispose()
            sysSvc = Nothing
            MessageBox.Show("Barcode is not found!")
            Return
        End If
        If (hwOptions.Barcode = HW_TYPE_BARCODE._2D_SWD_H Or hwOptions.Barcode = HW_TYPE_BARCODE._2D_SWD_M) Then
            System.Diagnostics.Debug.WriteLine(">>> Form1_Load is2DScanner true")
            is2DScanner = True
        Else
            System.Diagnostics.Debug.WriteLine(">>> Form1_Load is2DScanner false")
            is2DScanner = False
        End If

        'If another application is already using the barcode, you must shut down the application.
        Dim hBarcodeEmulator As IntPtr = _Native.Utils.FindWindow(BarcodeEmulatorInfo.WindowClass, BarcodeEmulatorInfo.WindowTitle)
        If (hBarcodeEmulator <> IntPtr.Zero) Then
            Utils.SendMessage(hBarcodeEmulator, Utils.WM_COMMAND, BarcodeEmulatorInfo.CloseID, 0)
        End If
        'create barcode object
        barcode = New BarcodeApi()
        Dim result As BARCODE_RESULT = barcode.Open()
        If (result <> BARCODE_RESULT.BARCODE_RESULT_SUCCESS) Then
            MessageBox.Show(result.ToString())
            Return
        End If
        'When decoding is successful, register a callback function to be executed.
        barcode.SetCallback(New BarcodeApi.BARCODECALLBACK(AddressOf barcodeCallbackProc))

        'Setting for receiving the H/W keys.
        'For more information, please refer to SystemService_CheckKeyPresses C# example.
        specifiedKeys = New ArrayList()
        specifiedKeys.Add(Convert.ToInt32(Keys.F7))
        specifiedKeys.Add(Convert.ToInt32(Keys.F8))
        specifiedKeys.Add(Convert.ToInt32(Keys.F9))
        specifiedKeys.Add(Convert.ToInt32(Keys.F10))
        specifiedKeys.Add(Convert.ToInt32(Keys.F11))
        specifiedKeys.Add(Convert.ToInt32(Keys.F19))
        specifiedKeys.Add(Convert.ToInt32(&HEF))
        specifiedKeys.Add(Convert.ToInt32(&HF0))
        specifiedKeys.Add(Convert.ToInt32(&HF2))
        specifiedKeys.Add(Convert.ToInt32(&HF3))
        specifiedKeys.Add(Convert.ToInt32(&HD3))
        specifiedKeys.Add(Convert.ToInt32(&HD2))

        If (is2DScanner = True) Then
            cbxLeaveLightOn.Items.Add("Be flashed on and off")
            cbxLeaveLightOn.Items.Add("Always on")
            Dim alwaysOn As Boolean = False
            barcode.GetLeaveLightsOn(alwaysOn)

            If (alwaysOn = True) Then
                cbxLeaveLightOn.SelectedIndex = 1
            Else
                cbxLeaveLightOn.SelectedIndex = 0
            End If
            cbxLightMode.Items.Add("Neither aimers nor illumination")
            cbxLightMode.Items.Add("Illumination only")
            cbxLightMode.Items.Add("Aimers only")
            cbxLightMode.Items.Add("Both aimers and illumination")
            cbxLightMode.SelectedIndex = 3
        Else
            cbxLeaveLightOn.Items.Add("LeaveLightOn not supported")
            cbxLeaveLightOn.SelectedIndex = 0
            cbxLightMode.Items.Add("LightMode not supported")
            cbxLightMode.SelectedIndex = 0

            chkRaw.Enabled = False
            cbxLeaveLightOn.Enabled = False
            cbxLightMode.Enabled = False
        End If
        Me.KeyPreview = True

        'Me.cbxLightMode.SelectedIndexChanged += New System.EventHandler(Me.cbxLightMode_SelectedIndexChanged)
        'Me.cbxLeaveLightOn.SelectedIndexChanged += New System.EventHandler(Me.cbxLeaveLightOn_SelectedIndexChanged)
        System.Diagnostics.Debug.WriteLine("<<< Form1_Load End ")
    End Sub
    Private Sub Form1_Closing(ByVal sender As System.Object, ByVal e As System.ComponentModel.CancelEventArgs) Handles MyBase.Closing
        System.Diagnostics.Debug.WriteLine(">>> Form1_Closing Start ")
        If (barcode IsNot Nothing) Then
            If (barcode.IsOpened()) Then
                System.Diagnostics.Debug.WriteLine(">>> Form1_Closing barcode Close ")
                barcode.Stop()
                barcode.Close()
                System.Diagnostics.Debug.WriteLine("<<< Form1_Closing barcode Close ")
            End If
            barcode = Nothing
        End If

        If (sysSvc IsNot Nothing) Then
            sysSvc.Dispose()
            sysSvc = Nothing
        End If
        System.Diagnostics.Debug.WriteLine("<<< Form1_Closing End ")
    End Sub

    Protected Overrides Sub OnKeyDown(ByVal e As System.Windows.Forms.KeyEventArgs)
        If (specifiedKeys.Contains(e.KeyValue)) Then
            If (barcode IsNot Nothing) Then
                If (chkRaw.Checked) Then
                    barcode.StartScanRawData()
                Else
                    barcode.Start()
                End If
            End If
        End If
        MyBase.OnKeyDown(e)
    End Sub
    Protected Overrides Sub OnKeyUp(ByVal e As System.Windows.Forms.KeyEventArgs)
        If (specifiedKeys.Contains(e.KeyValue)) Then
            If (barcode IsNot Nothing) Then
                If (chkRaw.Checked) Then
                    barcode.StopScanRawData()
                Else
                    barcode.Stop()
                End If
            End If
        End If

        MyBase.OnKeyUp(e)
    End Sub

    Public Sub vibratorCallbackProc(ByVal obj As Object)
        If sysSvc Is Nothing Then
            Return
        End If

        sysSvc.SetVibratorEnable(True)
        Thread.Sleep(250)
        sysSvc.SetVibratorEnable(False)

    End Sub
    Public Sub barcodeCallbackProc()
        System.Diagnostics.Debug.WriteLine(">>> barcodeCallbackProc Start")
        Dim byteValue() As Byte = New Byte(4096) {}
        Dim lenOfValue As Integer = 0
        Dim Value As New String(New Char(4096) {})
        Dim TypeName As New String(New Char(4096) {})
        Dim TypeID As New String(New Char(10) {})
        Dim i As Integer = 1
        If (barcode Is Nothing) Then
            Return
        End If

        If (chkRaw.Checked) Then
            Dim result As BARCODE_RESULT = barcode.GetBarcodeRawData(byteValue, lenOfValue, TypeName, TypeID)
            Value = String.Empty

            For i = 1 To lenOfValue Step 1
                Value += String.Format("{0:X2}", byteValue(i))
            Next i
        Else
            System.Diagnostics.Debug.WriteLine(">> GetBarcodeData Start")
            barcode.GetBarcodeData(Value, TypeName, TypeID)
            System.Diagnostics.Debug.WriteLine("<<< GetBarcodeData End")
            Value = Value.Substring(0, Value.IndexOf(Char.MinValue))
            TypeName = TypeName.Substring(0, TypeName.IndexOf(Char.MinValue))
            TypeID = TypeID.Substring(0, TypeID.IndexOf(Char.MinValue))
        End If

        System.Diagnostics.Debug.WriteLine(">>> ListViewItem Start")
        Dim item As ListViewItem = New ListViewItem(Convert.ToString(listView1.Items.Count + 1))
        item.SubItems.Add(Value)
        item.SubItems.Add(TypeName)
        listView1.Items.Add(item)
        listView1.EnsureVisible(listView1.Items.Count - 1)

        System.Diagnostics.Debug.WriteLine("<<< ListViewItem End")
        If (chkVibrator.Checked) Then
            ThreadPool.QueueUserWorkItem(New WaitCallback(AddressOf vibratorCallbackProc))
        End If
        If (chkSound.Checked) Then
            Utils.PlaySound("\Windows\Success.wav")
        End If
        System.Diagnostics.Debug.WriteLine("<<< barcodeCallbackProc End")
    End Sub
    Private Sub cbxLightMode_SelectedIndexChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles cbxLightMode.SelectedIndexChanged
        If (barcode Is Nothing) Then
            Return
        End If
        barcode.SetScanningLightsMode(cbxLightMode.SelectedIndex)

    End Sub


    Private Sub cbxLeaveLightOn_SelectedIndexChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles cbxLeaveLightOn.SelectedIndexChanged
        If (barcode Is Nothing) Then
            Return
        End If

        If (cbxLeaveLightOn.SelectedIndex = 1) Then
            barcode.SetLeaveLightsOn(True)
        Else
            barcode.SetLeaveLightsOn(False)
        End If
    End Sub


    Private Sub btnStop_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnStop.Click
        If (barcode Is Nothing) Then
            System.Diagnostics.Debug.WriteLine("<<< btnStop_Click barcode Nothing")
            Return
        End If
        If (chkRaw.Checked) Then
            barcode.StopScanRawData()
        Else
            barcode.Stop()
        End If
    End Sub

    Private Sub btnClear_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnClear.Click
        listView1.Items.Clear()
    End Sub

    Private Sub btnStart_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnStart.Click
        System.Diagnostics.Debug.WriteLine(">>> btnStart_Click barcode Start")
        If (barcode Is Nothing) Then
            System.Diagnostics.Debug.WriteLine("<<< btnStart_Click barcode Nothing")
            Return
        End If

        If (chkRaw.Checked) Then
            barcode.StartScanRawData()
        Else
            barcode.Start()
        End If
        System.Diagnostics.Debug.WriteLine("<<< btnStart_Click barcode End")

    End Sub

End Class
