﻿Imports System.Runtime.InteropServices
Public Class _Native

    Public Enum PlaySoundFlags
        SND_SYNC = &H0
        SND_ASYNC = &H1
        SND_NODEFAULT = &H2
        SND_MEMORY = &H4
        SND_LOOP = &H8
        SND_NOSTOP = &H10
        SND_NOWAIT = &H2000
        SND_ALIAS = &H10000
        SND_ALIAS_ID = &H110000
        SND_FILENAME = &H20000
        SND_RESOURCE = &H40004

    End Enum

    Public Class BarcodeEmulatorInfo
        Public Shared ReadOnly Property FileName() As String
            Get
                If (Utils.IsWinCE = True) Then
                    Return "\Windows\DEMO_ScanEmulator.exe"
                Else
                    Return "\Program Files\ATID_DemoApps\BarcodeEmulatorWM.exe"
                End If
            End Get
        End Property

        Public Shared ReadOnly Property WindowClass() As String
            Get
                If (Utils.IsWinCE = True) Then
                    Return "ScanEmul"
                Else
                    Return "__ATID__BARCODE__EMULATOR__"
                End If
            End Get
        End Property

        Public Shared ReadOnly Property WindowTitle() As String
            Get
                If (Utils.IsWinCE = True) Then
                    Return "ScanEmul"
                Else
                    Return "BarcodeEmulator"
                End If
            End Get
        End Property

        Public Shared ReadOnly Property CloseID() As UInteger
            Get
                If (Utils.IsWinCE = True) Then
                    Return CUInt(40011)
                Else
                    Return CUInt(40001)
                End If
            End Get
        End Property
    End Class

    Public Class Utils
        Public Const WM_DESTROY As UInteger = &H2
        Public Const WM_CLOSE As UInteger = &H10
        Public Const WM_QUIT As UInteger = &H12
        Public Const WM_COMMAND As UInteger = &H111
        Public Const NETCF_WND_CLASS_NAME As String = "#NETCF_AGL_BASE_"

        <DllImport("coredll.dll", EntryPoint:="SendMessage", SetLastError:=True)> _
        Public Shared Function SendMessage(ByVal hWnd As IntPtr, ByVal Msg As UInteger, ByVal wParam As UInteger, ByVal lParam As UInteger) As IntPtr
        End Function

        <DllImport("coredll.dll", EntryPoint:="FindWindowW", SetLastError:=True)> _
       Public Shared Function FindWindow(ByVal lpClassName As String, ByVal lpWindowName As String) As IntPtr
        End Function

        <DllImport("coredll.dll", EntryPoint:="SetForegroundWindow", SetLastError:=True)> _
        Public Shared Function SetForegroundWindow(ByVal hWnd As IntPtr) As Boolean
        End Function

        <DllImport("coredll.dll", EntryPoint:="ShowWindow", SetLastError:=True)> _
        Public Shared Function ShowWindow(ByVal hWnd As IntPtr, ByVal nCmdShow As Integer) As Boolean
        End Function

        <DllImport("coredll.dll", EntryPoint:="PlaySound", SetLastError:=True)> _
        Public Shared Function PlaySound(ByVal szSound As String, ByVal hModule As IntPtr, ByVal flags As Integer) As Integer
        End Function

        Public Shared Function PlaySound(ByVal szSound As String) As Boolean
            Dim nRtn As Integer = PlaySound(szSound, IntPtr.Zero, (PlaySoundFlags.SND_FILENAME Or PlaySoundFlags.SND_ASYNC))

            If (nRtn > 0) Then
                Return True
            Else
                Return False
            End If
        End Function

        Public Shared ReadOnly Property IsWinCE() As Boolean
            Get
                If (Environment.OSVersion.Version.Minor = 2) Then
                    Return False
                Else
                    Return True
                End If
            End Get
        End Property

    End Class
End Class
