﻿Imports RFID_VB._Native
Imports NSysSvcApi
Imports System.Threading
Imports NRfidApi
Imports System.Collections



Public Class Form1

    Public sysService As NSysSvcApi.SysSvcApi = Nothing
    Public Shared rfid As RfidApi = Nothing
    Public result As RFID_RESULT = RFID_RESULT.RFID_RESULT_FAILURE
    Public Shared qTags As Queue = Nothing
    Public Shared htTags As Hashtable = Nothing
    Public eventStartDequeue As AutoResetEvent = Nothing
    Public threadDequeue As Thread = Nothing
    Public Shared exitThread As Boolean = False
    Public Shared isRunning As Boolean = False
    Public Const title As String = "RFID Example"
    Public m_nMaxPower As UInteger = 0
    Public Const ACCESS_TIME_SECONDS As Integer = 3
    Public Const ACCESS_TIME_UNLIMITED As Integer = 0
    Public Delegate Sub delegateSetButtons(ByVal enable As Boolean)
    Public Delegate Sub delegateAddListViewItem(ByVal item As ListViewItem)
    Public Delegate Sub delegateModifyListViewItem(ByVal index As Integer, ByVal count As Integer)

    Public Structure TagInfo
        Public index As Integer
        Public count As Integer
    End Structure

    Private Sub Form1_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load
        Me.Text = title
        Me.MinimizeBox = False
        Me.MaximizeBox = False

        If (Utils.IsWinCE = True) Then
            Me.Menu = Nothing
        End If
        sysService = New SysSvcApi()
        Dim hwOptions As HW_OPTIONS = New HW_OPTIONS()

        sysService.GetHardwareOptions(hwOptions)
        If (hwOptions.UHF = HW_TYPE_UHF.NONE) Then
            sysService.Dispose()
            sysService = Nothing
            MessageBox.Show("RFID is not found!")
            Return
        End If

        rfid = New RfidApi()
        result = rfid.PowerOn()
        If (result <> RFID_RESULT.RFID_RESULT_SUCCESS) Then
            MessageBox.Show("PowerOn : " + result.ToString())
            Return
        End If
        result = rfid.Open()
        If (result <> RFID_RESULT.RFID_RESULT_SUCCESS) Then
            rfid.PowerOff()
            MessageBox.Show("Open : " + result.ToString())
            Return
        End If

        comboBox1.Items.Add("S0")
        comboBox1.Items.Add("S1")
        comboBox1.Items.Add("S2")
        comboBox1.Items.Add("S3")


        Select Case (rfid.Session)
            Case NRfidApi.SESSION_TYPE.SESSION_0
                comboBox1.SelectedIndex = 0
            Case SESSION_TYPE.SESSION_1
                comboBox1.SelectedIndex = 1
            Case SESSION_TYPE.SESSION_2
                comboBox1.SelectedIndex = 2
            Case SESSION_TYPE.SESSION_3
                comboBox1.SelectedIndex = 3
            Case Else
                comboBox1.Enabled = False
        End Select

        comboBox2.Items.Add("A")
        comboBox2.Items.Add("B")
        comboBox2.Items.Add("AB")


        Select Case (rfid.InventoryTarget)
            Case INVENTORIED_STATE.STATE_A
                comboBox2.SelectedIndex = 0
            Case INVENTORIED_STATE.STATE_B
                comboBox2.SelectedIndex = 1
            Case INVENTORIED_STATE.STATE_AB
                comboBox2.SelectedIndex = 2
            Case Else
                comboBox2.Enabled = False
        End Select

        Dim i As Integer = 0
        For i = 1 To 24 Step 1
            comboBox3.Items.Add(i.ToString())
        Next i

        Dim nMaxPower As UInteger = 0
        Dim nPower As UInteger = 0

        ' sets the power level
        nMaxPower = rfid.MaxPwr
        System.Diagnostics.Debug.WriteLine("nPower:" + nMaxPower.ToString())
        nPower = rfid.PowerLevel

        If (nMaxPower = 0) Then
            nMaxPower = 300
        End If

        Select Case (nMaxPower.ToString().Remove(2, 1))
            Case "30"
                Dim a As Integer = 25
                For a = 25 To 30 Step 1
                    comboBox3.Items.Add(a.ToString())
                Next a
                m_nMaxPower = 30
            Case "28"
                Dim a As Integer = 25
                For a = 25 To 28 Step 1
                    comboBox3.Items.Add(a.ToString())
                Next a
                m_nMaxPower = 28
            Case "27"
                Dim a As Integer = 25
                For a = 25 To 27 Step 1
                    comboBox3.Items.Add(a.ToString())
                Next a
                m_nMaxPower = 27
            Case "24"
                m_nMaxPower = 24

            Case Else
                Dim a As Integer = 25
                For a = 25 To 30 Step 1
                    comboBox3.Items.Add(a.ToString())
                Next a
                m_nMaxPower = 30
        End Select

        comboBox3.Text = (m_nMaxPower - rfid.PowerLevel).ToString()


        Dim fwver As String = rfid.FirmwareVersion
        numericUpDown1.Value = rfid.QValue

        rfid.SetCallback(New RfidCallbackProc(AddressOf rfidCallbackProc))

        htTags = New Hashtable()

        qTags = New Queue()

        eventStartDequeue = New AutoResetEvent(False)
        exitThread = False
        threadDequeue = New Thread(New ThreadStart(AddressOf threadDequeueProc))
        threadDequeue.IsBackground = True
        threadDequeue.Start()

    End Sub
    Private Sub Form1_Closing(ByVal sender As System.Object, ByVal e As System.ComponentModel.CancelEventArgs) Handles MyBase.Closing
        If (sysService IsNot Nothing) Then
            sysService.Dispose()
            sysService = Nothing
        End If

        If (rfid IsNot Nothing) Then
            If (rfid.IsRunning()) Then
                rfid.Stop()
            End If
            rfid.Close()
            rfid.PowerOff()
            rfid = Nothing
        End If

        If (threadDequeue IsNot Nothing) Then
            exitThread = True
            eventStartDequeue.Set()
            threadDequeue.Join()
            threadDequeue = Nothing
        End If

        If (eventStartDequeue IsNot Nothing) Then
            eventStartDequeue.Close()
            eventStartDequeue = Nothing
        End If
    End Sub

    Public Sub rfidCallbackProc(ByVal cbData As RFIDCALLBACKDATA)
        Dim buff As String = New String(New Char(1024) {})
        If (rfid Is Nothing) Then
            Return
        End If

        rfid.GetResult(buff, cbData.CallbackType, cbData.wParam, cbData.lParam)

        If (cbData.CallbackType = RFID_CALLBACK_TYPE.RFIDCALLBACKTYPE_DATA) Then
            qTags.Enqueue(buff)
        Else
            If (buff.StartsWith("Multi Read Stop")) Then
                isRunning = False
                System.Diagnostics.Debug.WriteLine("Reply : " + buff)
            End If
        End If
    End Sub
    Public Sub threadDequeueProc()
        System.Diagnostics.Debug.WriteLine("+++ threadDequeueProc ")
        Dim temp As String = String.Empty
        Dim data As String = String.Empty
        Dim tagInfo As TagInfo

        While (exitThread = False)
            eventStartDequeue.WaitOne()
            While (qTags.Count > 0 Or isRunning)
                If (qTags.Count < 1) Then
                    Thread.Sleep(1)
                    Continue While
                End If

                temp = CStr(qTags.Dequeue())
                If (String.IsNullOrEmpty(temp) = False) Then
                    data = temp.Substring(0, temp.IndexOf(Char.MinValue))

                    If (htTags.Contains(data)) Then
                        tagInfo = CType(htTags(data), TagInfo)
                        tagInfo.count = tagInfo.count + 1
                        htTags(data) = tagInfo
                        BeginInvoke(New delegateModifyListViewItem(AddressOf ModifyListViewItem), tagInfo.index, tagInfo.count)
                    Else
                        tagInfo = New TagInfo()
                        tagInfo.index = htTags.Count
                        tagInfo.count = 1
                        htTags.Add(data, tagInfo)
                        Dim item As ListViewItem = New ListViewItem(data)
                        item.SubItems.Add(tagInfo.count.ToString())
                        BeginInvoke(New delegateAddListViewItem(AddressOf AddListViewItem), item)
                    End If
                Else
                    Thread.Sleep(1)
                End If
            End While
            BeginInvoke(New delegateSetButtons(AddressOf SetButtons), True)
        End While
        System.Diagnostics.Debug.WriteLine("--- threadDequeueProc ")
    End Sub
    Public Sub ModifyListViewItem(ByVal index As Integer, ByVal count As Integer)
        listView1.Items(index).SubItems(1).Text = count.ToString()
    End Sub

    Public Sub AddListViewItem(ByVal lvItem As ListViewItem)
        listView1.Items.Add(lvItem)
    End Sub

    Public Sub SetButtons(ByVal enable As Boolean)
        btnClear.Enabled = enable
        btnRead.Enabled = enable
        btnWrite.Enabled = enable
        btnLock.Enabled = enable
        btnKill.Enabled = enable

        If (enable = True) Then
            btnInventory.Text = "Start inventory"
        Else
            btnInventory.Text = "Stop inventory"
        End If
    End Sub

    Public Function GetSelectedTag() As String
        If (listView1.SelectedIndices.Count < 1) Then
            Return String.Empty
        End If
        Dim idx As Integer = listView1.SelectedIndices(0)
        Return listView1.Items(idx).Text
    End Function

    Private Sub btnClear_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnClear.Click
        htTags.Clear()
        qTags.Clear()
        listView1.Items.Clear()
    End Sub

    Private Sub btnInventory_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnInventory.Click
        If (rfid Is Nothing) Then
            Return
        End If

        If (btnInventory.Text.Equals("Start inventory")) Then
            result = rfid.ReadEpc(False, RFID_READ_TYPE.EPC_GEN2_MULTI_TAG, Nothing)
            If (result <> RFID_RESULT.RFID_RESULT_SUCCESS) Then
                MessageBox.Show("ReadEpc : " + result.ToString())
                Return

            End If
            isRunning = True
            SetButtons(False)
            eventStartDequeue.Set()
        Else
            result = rfid.Stop()
            If (result <> RFID_RESULT.RFID_RESULT_SUCCESS) Then
                MessageBox.Show("Stop : " + result.ToString())
                Return
            End If
        End If
    End Sub

    Private Sub btnKill_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnKill.Click
        If (rfid Is Nothing) Then
            Return
        End If
        Dim read As DialogResult = New frmKill(GetSelectedTag()).ShowDialog()
    End Sub

    Private Sub btnWrite_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnWrite.Click
        If (rfid Is Nothing) Then
            Return
        End If
        Dim read As DialogResult = New frmWrite(GetSelectedTag()).ShowDialog()
    End Sub

    Private Sub btnLock_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnLock.Click
        If (rfid Is Nothing) Then
            Return
        End If
        Dim read As DialogResult = New frmLock(GetSelectedTag()).ShowDialog()
    End Sub

    Private Sub btnRead_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnRead.Click
        If (rfid Is Nothing) Then
            Return
        End If
        Dim read As DialogResult = New frmRead(GetSelectedTag()).ShowDialog()
    End Sub

    Private Sub comboBox1_SelectedIndexChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles comboBox1.SelectedIndexChanged
        Select Case (comboBox1.SelectedIndex)
            Case 0
                rfid.Session = SESSION_TYPE.SESSION_0
            Case 1
                rfid.Session = SESSION_TYPE.SESSION_1
            Case 2
                rfid.Session = SESSION_TYPE.SESSION_2
            Case 3
                rfid.Session = SESSION_TYPE.SESSION_3
        End Select
    End Sub

    Private Sub comboBox2_SelectedIndexChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles comboBox2.SelectedIndexChanged
        Select Case (comboBox2.SelectedIndex)
            Case 0
                rfid.InventoryTarget = INVENTORIED_STATE.STATE_A
            Case 1
                rfid.InventoryTarget = INVENTORIED_STATE.STATE_B
            Case 2
                rfid.InventoryTarget = INVENTORIED_STATE.STATE_AB
        End Select
    End Sub

    Private Sub comboBox3_SelectedIndexChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles comboBox3.SelectedIndexChanged
        Dim nPower As UInteger = CUInt(comboBox3.Text)
        System.Diagnostics.Debug.WriteLine("Value : " + nPower.ToString())
        rfid.PowerLevel = m_nMaxPower - nPower
    End Sub

    Private Sub numericUpDown1_ValueChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles numericUpDown1.ValueChanged
        rfid.QValue = CUInt(numericUpDown1.Value)
    End Sub
End Class
