﻿Imports NRfidApi
Imports NSysSvcApi
Imports RFID_VB._Native
Imports System.Collections
Public Class frmLock
    Public targetTag As String = String.Empty
    Dim result As RFID_RESULT = RFID_RESULT.RFID_RESULT_FAILURE
    Public Sub New(ByVal _epc As String)

        ' 이 호출은 Windows Form 디자이너에 필요합니다.
        InitializeComponent()

        ' InitializeComponent() 호출 뒤에 초기화 코드를 추가하십시오.
        Me.Text = "Lock Example"
        Me.MinimizeBox = False
        Me.MaximizeBox = False

        If (Utils.IsWinCE) Then
            Me.Menu = Nothing
            panel1.Location = New Point(0, 0)
        End If

        Me.targetTag = _epc

        Dim maxTargetLength As Integer = RfidApi.MAX_MASK_BYTES * 2
        If (Me.targetTag.Length > maxTargetLength) Then
            Me.targetTag = Me.targetTag.Substring(0, maxTargetLength)
        End If

        tbxTargetTag.Text = targetTag

        cbxAction.Items.Add("Lock")
        cbxAction.Items.Add("UnLock")
        cbxAction.Items.Add("Permalock")
        cbxAction.Items.Add("Permaunlock")
        cbxAction.SelectedIndex = 0
        Form1.rfid.OperationTime = Form1.ACCESS_TIME_SECONDS
    End Sub
    Private Sub frmLock_Closing(ByVal sender As System.Object, ByVal e As System.ComponentModel.CancelEventArgs) Handles MyBase.Closing
        Form1.rfid.OperationTime = Form1.ACCESS_TIME_UNLIMITED
    End Sub

    Public Sub AddString(ByVal str As String)
        listBox1.Items.Add(str)
        listBox1.SelectedIndex = listBox1.Items.Count - 1
    End Sub


    Private Sub cbxAction_SelectedIndexChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles cbxAction.SelectedIndexChanged
        Select Case (cbxAction.SelectedIndex)
            Case 0
                btnAction.Text = "Do Lock"
            Case 1
                btnAction.Text = "Do UnLock"
            Case 2
                btnAction.Text = "Do Perma-lock"
            Case 3
                btnAction.Text = "Do Perma-unlock"
        End Select
    End Sub


    Private Sub btnAction_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnAction.Click
        Dim accessPassword As String = Nothing
        Dim maskParam As RFIDMASKPARAMS = New RFIDMASKPARAMS()
        Dim lockField As LOCKUNLOCKFIELD = New LOCKUNLOCKFIELD()

        If (String.IsNullOrEmpty(tbxAccessPassword.Text) = False) Then
            If (tbxAccessPassword.Text.Length <> 8) Then
                MessageBox.Show("Access password is 4 bytes")
                tbxAccessPassword.Focus()
                tbxAccessPassword.SelectAll()
                Return
            End If
        End If
        accessPassword = tbxAccessPassword.Text.Trim()

        If (String.IsNullOrEmpty(tbxTargetTag.Text) = False) Then
            maskParam.MemBank = MEM_BANK.EPC
            maskParam.nOffSet = 4
            maskParam.MaskPattern = tbxTargetTag.Text.Trim()
        End If

        btnAction.Enabled = False
        Cursor.Current = Cursors.WaitCursor

        Select Case (cbxAction.SelectedIndex)
            Case 0
                lockField.bAccessPassword = chkAccessPassword.Checked
                lockField.bEPC = chkEPC.Checked
                lockField.bKillPassword = chkKillPassword.Checked
                lockField.bTID = chkTID.Checked
                lockField.bUSER = chkUSER.Checked

                result = Form1.rfid.LockField(True, lockField, False, accessPassword, maskParam)
            Case 1
                lockField.bAccessPassword = chkAccessPassword.Checked
                lockField.bEPC = chkEPC.Checked
                lockField.bKillPassword = chkKillPassword.Checked
                lockField.bTID = chkTID.Checked
                lockField.bUSER = chkUSER.Checked

                result = Form1.rfid.UnLockField(True, lockField, False, accessPassword, maskParam)
            Case 2
                If (chkKillPassword.Checked) Then
                    result = Form1.rfid.Permalock(True, PERMALOCK_FIELD.KILL_PASSWORD, True, False, accessPassword, maskParam)
                    AddString(result.ToString())
                End If
                If (chkAccessPassword.Checked) Then
                    result = Form1.rfid.Permalock(True, PERMALOCK_FIELD.ACCESS_PASSWORD, True, False, accessPassword, maskParam)
                    AddString(result.ToString())
                End If
                If (chkEPC.Checked) Then
                    result = Form1.rfid.Permalock(True, PERMALOCK_FIELD.EPC, True, False, accessPassword, maskParam)
                    AddString(result.ToString())
                End If
                If (chkTID.Checked) Then
                    result = Form1.rfid.Permalock(True, PERMALOCK_FIELD.TID, True, False, accessPassword, maskParam)
                    AddString(result.ToString())
                End If
                If (chkUSER.Checked) Then
                    result = Form1.rfid.Permalock(True, PERMALOCK_FIELD.USER, True, False, accessPassword, maskParam)
                End If
            Case 3
                If (chkKillPassword.Checked) Then
                    result = Form1.rfid.Permalock(True, PERMALOCK_FIELD.KILL_PASSWORD, False, False, accessPassword, maskParam)
                    AddString(result.ToString())
                End If
                If (chkAccessPassword.Checked) Then
                    result = Form1.rfid.Permalock(True, PERMALOCK_FIELD.ACCESS_PASSWORD, False, False, accessPassword, maskParam)
                    AddString(result.ToString())
                End If
                If (chkEPC.Checked) Then
                    result = Form1.rfid.Permalock(True, PERMALOCK_FIELD.EPC, False, False, accessPassword, maskParam)
                    AddString(result.ToString())
                End If
                If (chkTID.Checked) Then
                    result = Form1.rfid.Permalock(True, PERMALOCK_FIELD.TID, False, False, accessPassword, maskParam)
                    AddString(result.ToString())
                End If
                If (chkUSER.Checked) Then
                    result = Form1.rfid.Permalock(True, PERMALOCK_FIELD.USER, False, False, accessPassword, maskParam)
                End If
        End Select
        Cursor.Current = Cursors.Default
        btnAction.Enabled = True
        AddString(result.ToString())


        If (result = RFID_RESULT.RFID_RESULT_SUCCESS) Then
            Utils.PlaySound("\Windows\Success.wav")
        Else
            Utils.PlaySound("\Windows\Fail.wav")

        End If
    End Sub
End Class