﻿Imports NRfidApi
Imports NSysSvcApi
Imports RFID_VB._Native
Imports System.Collections
Public Class frmRead
    Public targetTag As String = String.Empty
    Dim result As RFID_RESULT = RFID_RESULT.RFID_RESULT_FAILURE
    Dim buff As String = New String(New Char(1024) {})

    Public Sub New(ByVal _epc As String)

        ' 이 호출은 Windows Form 디자이너에 필요합니다.
        InitializeComponent()
        ' InitializeComponent() 호출 뒤에 초기화 코드를 추가하십시오.
        Me.Text = "Read Example"
        Me.MinimizeBox = False
        Me.MaximizeBox = False

        If (Utils.IsWinCE = True) Then
            Me.Menu = Nothing
            Panel1.Location = New Point(0, 0)
        End If
        Me.targetTag = _epc

        Dim maxTargetLength As Integer = RfidApi.MAX_MASK_BYTES * 2
        If (Me.targetTag.Length > maxTargetLength) Then
            Me.targetTag = Me.targetTag.Substring(0, maxTargetLength)
        End If

        tbxTargetTag.Text = targetTag

        cbxMemBank.Items.Add("RESERVED")
        cbxMemBank.Items.Add("EPC")
        cbxMemBank.Items.Add("TID")
        cbxMemBank.Items.Add("USER")
        cbxMemBank.SelectedIndex = 1

        Dim idx As Integer = 0
        For idx = 0 To 255 Step 1
            cbxWordPtr.Items.Add(idx.ToString())
        Next idx
        cbxWordPtr.SelectedIndex = 2

        For idx = 1 To 255 Step 1
            cbxWordCnt.Items.Add(idx.ToString())
        Next idx
        cbxWordCnt.SelectedIndex = 5

        cbxPreDefined.Items.Add("User defined")
        cbxPreDefined.Items.Add("Access password")
        cbxPreDefined.Items.Add("Kill password")
        cbxPreDefined.Items.Add("Protocol-control word")
        cbxPreDefined.SelectedIndex = 0

        Form1.rfid.OperationTime = Form1.ACCESS_TIME_SECONDS
    End Sub

    Private Sub frmRead_Closing(ByVal sender As System.Object, ByVal e As System.ComponentModel.CancelEventArgs) Handles MyBase.Closing
        Form1.rfid.OperationTime = Form1.ACCESS_TIME_UNLIMITED
    End Sub

    Public Sub AddString(ByVal str As String)
        listBox1.Items.Add(str)
        listBox1.SelectedIndex = listBox1.Items.Count - 1

    End Sub


    Private Sub cbxPreDefined_SelectedIndexChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles cbxPreDefined.SelectedIndexChanged
        Dim idx As Integer = cbxPreDefined.SelectedIndex
        Select Case (idx)
            Case 0
                cbxMemBank.SelectedIndex = 1
                cbxWordPtr.SelectedIndex = 2
                cbxWordCnt.SelectedIndex = 5
            Case 1
                cbxMemBank.SelectedIndex = 0
                cbxWordPtr.SelectedIndex = 2
                cbxWordCnt.SelectedIndex = 1
            Case 2
                cbxMemBank.SelectedIndex = 0
                cbxWordPtr.SelectedIndex = 0
                cbxWordCnt.SelectedIndex = 1
            Case 3
                cbxMemBank.SelectedIndex = 1
                cbxWordPtr.SelectedIndex = 1
                cbxWordCnt.SelectedIndex = 0
        End Select
        If (idx = 0) Then
            cbxMemBank.Enabled = True
            cbxWordPtr.Enabled = True
            cbxWordCnt.Enabled = True
        Else
            cbxMemBank.Enabled = False
            cbxWordPtr.Enabled = False
            cbxWordCnt.Enabled = False
        End If



    End Sub

    Private Sub btnRead_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnRead.Click
        Dim memBank As MEM_BANK = MEM_BANK.EPC
        Dim wordPtr As UInteger = 0
        Dim wordCnt As UInteger = 0
        Dim accessPassword As String = Nothing
        Dim maskParam As RFIDMASKPARAMS = New RFIDMASKPARAMS()
        Dim data As String = String.Empty
        Select Case (cbxMemBank.SelectedIndex)
            Case 0
                memBank = MEM_BANK.RESERVED
            Case 1
                memBank = MEM_BANK.EPC
            Case 2
                memBank = MEM_BANK.TID
            Case 3
                memBank = MEM_BANK.USER
        End Select
        wordPtr = CUInt(cbxWordPtr.SelectedItem.ToString())
        wordCnt = CUInt(cbxWordCnt.SelectedItem.ToString())

        If (String.IsNullOrEmpty(tbxAccessPassword.Text) = False) Then
            If (tbxAccessPassword.Text.Length <> 8) Then
                MessageBox.Show("Access password is 4 bytes")
                tbxAccessPassword.Focus()
                tbxAccessPassword.SelectAll()
                Return
            End If
        End If
        accessPassword = tbxAccessPassword.Text.Trim()

        If (String.IsNullOrEmpty(tbxTargetTag.Text) = False) Then
            maskParam.MemBank = MEM_BANK.EPC
            maskParam.nOffSet = 4
            maskParam.MaskPattern = tbxTargetTag.Text.Trim()

        End If

        btnRead.Enabled = False
        Cursor.Current = Cursors.WaitCursor
        result = Form1.rfid.ReadMemBank(True, memBank, wordPtr, wordCnt, False, accessPassword, maskParam, buff)
        Cursor.Current = Cursors.Default
        btnRead.Enabled = True

        If (result = RFID_RESULT.RFID_RESULT_SUCCESS) Then
            data = buff.Substring(0, buff.IndexOf(Char.MinValue))
            AddString(data)
            Utils.PlaySound("\Windows\Success.wav")
        Else
            AddString(result.ToString())
            Utils.PlaySound("\Windows\Fail.wav")

        End If

    End Sub
End Class