﻿Imports SystemService_VB._Native
Imports NSysSvcApi
Imports System.Threading
Imports System.Collections
Public Class Form1
    Public Const title As String = "SystemService Example"
    Public sysService As SysSvcApi = Nothing
    Public result As SYSSVC_RESULT = SYSSVC_RESULT.SYSSVC_RESULT_FAILURE
    Public hwOptions As HW_OPTIONS
    Public keypadStatus As KBD_STATUS = KBD_STATUS.KBD_STATUS_NUMERIC
    Public Const WIRELESS_DEVICE_WLAN As Integer = 0
    Public Const WIRELESS_DEVICE_BLUETOOTH As Integer = 2

    Public Sub New()

        ' 이 호출은 Windows Form 디자이너에 필요합니다.
        InitializeComponent()

        ' InitializeComponent() 호출 뒤에 초기화 코드를 추가하십시오.

        Me.Text = title
        Me.MinimizeBox = False
        Me.MaximizeBox = False

        If (Utils.IsWinCE = True) Then
            Me.Menu = Nothing
            panel1.Location = New Point(0, 0)
        End If

        sysService = New SysSvcApi()
        hwOptions = New HW_OPTIONS()

        tbxDeviceID.Text = sysService.DeviceID
        result = sysService.GetHardwareOptions(hwOptions)
        If (result <> SYSSVC_RESULT.SYSSVC_RESULT_SUCCESS) Then
            sysService.Dispose()
            sysService = Nothing
            MessageBox.Show("GetHardwareOptions : " + result.ToString())
            Return
        End If

        Dim nStatus As Integer = 0
        If (hwOptions.WLAN = HW_TYPE_WLAN.NONE) Then
            chkWiFi.Enabled = False
        Else
            chkWiFi.Enabled = True
        End If

        If (chkWiFi.Enabled) Then
            result = sysService.GetWirelessDevicesPowerState(WIRELESS_DEVICE_WLAN, nStatus)
            If (result <> SYSSVC_RESULT.SYSSVC_RESULT_SUCCESS) Then
                sysService.Dispose()
                sysService = Nothing
                MessageBox.Show("GetWirelessDevicesPowerState : " + result.ToString())
                Return
            End If
            If (nStatus = 1) Then
                chkWiFi.Checked = True
            Else
                chkWiFi.Checked = False
            End If
        End If

        If (hwOptions.Bluetooth = HW_TYPE_BLUETOOTH.NONE) Then
            chkBluetooth.Enabled = False
        Else
            chkBluetooth.Enabled = True
        End If

        If (chkBluetooth.Enabled) Then
            result = sysService.GetWirelessDevicesPowerState(WIRELESS_DEVICE_BLUETOOTH, nStatus)
            If (result <> SYSSVC_RESULT.SYSSVC_RESULT_SUCCESS) Then
                sysService.Dispose()
                sysService = Nothing
                MessageBox.Show("GetWirelessDevicesPowerState : " + result.ToString())
                Return
            End If
            If (nStatus = 1) Then
                chkBluetooth.Checked = True
            Else
                chkBluetooth.Checked = False
            End If
        End If

        cbxMode.SelectedIndex = 0

        result = sysService.GetKBDStatus(keypadStatus)
        If (result <> SYSSVC_RESULT.SYSSVC_RESULT_SUCCESS) Then
            sysService.Dispose()
            sysService = Nothing
            MessageBox.Show("GetKBDStatus : " + result.ToString())
            Return
        End If

        Select Case (keypadStatus)
            Case KBD_STATUS.KBD_STATUS_LOWER_CASE
                cbxKeypadStatus.SelectedIndex = 0
            Case KBD_STATUS.KBD_STATUS_NUMERIC
                cbxKeypadStatus.SelectedIndex = 1
            Case KBD_STATUS.KBD_STATUS_UPPER_CASE
                cbxKeypadStatus.SelectedIndex = 2
        End Select

    End Sub
    Private Sub Form1_Closing(ByVal sender As System.Object, ByVal e As System.ComponentModel.CancelEventArgs) Handles MyBase.Closing
        If (sysService IsNot Nothing) Then
            sysService.Dispose()
            sysService = Nothing

        End If
    End Sub

    Public Sub ReadPowerAndBacklightStatus(ByVal mode As Byte)
        If (sysService Is Nothing) Then
            Return
        End If

        Dim nValue As UShort = 0
        result = sysService.SuspendReadTimeoutValue(mode, nValue)
        If (result <> SYSSVC_RESULT.SYSSVC_RESULT_SUCCESS) Then
            MessageBox.Show("SuspendReadTimeoutValue : " + result.ToString())
        End If
        nudTurnOffDevice.Value = nValue
        System.Diagnostics.Debug.WriteLine(String.Format("SuspendReadTimeoutValue mode:{0}, value:{1}", mode, nValue))

        result = sysService.BacklightReadTimeoutValue(mode, nValue)
        If (result <> SYSSVC_RESULT.SYSSVC_RESULT_SUCCESS) Then
            MessageBox.Show("BacklightReadTimeoutValue : " + result.ToString())
        End If
        nudTurnOffBacklight.Value = nValue
        System.Diagnostics.Debug.WriteLine(String.Format("BacklightReadTimeoutValue mode:{0}, value:{1}", mode, nValue))

        result = sysService.BacklightReadBrightness(mode, nValue)
        If (result <> SYSSVC_RESULT.SYSSVC_RESULT_SUCCESS) Then
            MessageBox.Show("BacklightReadBrightness : " + result.ToString())
        End If
        nudBacklightBrightness.Value = nValue
        System.Diagnostics.Debug.WriteLine(String.Format("BacklightReadBrightness mode:{0}, value:{1}", mode, nValue))

    End Sub


    Private Sub chkWiFi_CheckStateChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles chkWiFi.CheckStateChanged
        If (sysService Is Nothing) Then
            Return
        End If
        Dim turnOn As Boolean = chkWiFi.Checked

        Cursor.Current = Cursors.WaitCursor

        If (turnOn) Then
            result = sysService.SetWirelessDevicesPowerState(WIRELESS_DEVICE_WLAN, 1)
        Else
            result = sysService.SetWirelessDevicesPowerState(WIRELESS_DEVICE_WLAN, 0)
        End If

        If (result <> SYSSVC_RESULT.SYSSVC_RESULT_SUCCESS) Then
            Utils.PlaySound("\Windows\Fail.wav")
            MessageBox.Show("SetWirelessDevicesPowerState : " + result.ToString())
        Else
            Utils.PlaySound("\Windows\Success.wav")
        End If
        Cursor.Current = Cursors.Default
    End Sub


    Private Sub chkBluetooth_CheckStateChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles chkBluetooth.CheckStateChanged
        If (sysService Is Nothing) Then
            Return
        End If
        Dim turnOn As Boolean = chkBluetooth.Checked

        Cursor.Current = Cursors.WaitCursor
        If (turnOn) Then
            result = sysService.SetWirelessDevicesPowerState(WIRELESS_DEVICE_BLUETOOTH, 1)
        Else
            result = sysService.SetWirelessDevicesPowerState(WIRELESS_DEVICE_BLUETOOTH, 0)
        End If

        If (result <> SYSSVC_RESULT.SYSSVC_RESULT_SUCCESS) Then
            Utils.PlaySound("\Windows\Fail.wav")
            MessageBox.Show("SetWirelessDevicesPowerState : " + result.ToString())
        Else
            Utils.PlaySound("\Windows\Success.wav")
        End If
        Cursor.Current = Cursors.Default
    End Sub


    Private Sub chkVibrator_CheckStateChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles chkVibrator.CheckStateChanged
        If (sysService Is Nothing) Then
            Return
        End If

        Dim turnOn As Boolean = chkVibrator.Checked
        Cursor.Current = Cursors.WaitCursor

        result = sysService.SetVibratorEnable(turnOn)

        If (result <> SYSSVC_RESULT.SYSSVC_RESULT_SUCCESS) Then
            Utils.PlaySound("\Windows\Fail.wav")
            MessageBox.Show("SetVibratorEnable : " + result.ToString())
        Else
            Utils.PlaySound("\Windows\Success.wav")
        End If
        Cursor.Current = Cursors.Default
    End Sub


    Private Sub chkFlashLight_CheckStateChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles chkFlashLight.CheckStateChanged
        If (sysService Is Nothing) Then
            Return
        End If

        Dim turnOn As Boolean = chkFlashLight.Checked

        Cursor.Current = Cursors.WaitCursor
        result = sysService.EnableFlashLight(turnOn)
        If (result <> SYSSVC_RESULT.SYSSVC_RESULT_SUCCESS) Then
            Utils.PlaySound("\Windows\Fail.wav")
            MessageBox.Show("EnableFlashLight : " + result.ToString())
        Else
            Utils.PlaySound("\Windows\Success.wav")
        End If
        Cursor.Current = Cursors.Default
    End Sub


    Private Sub cbxMode_SelectedIndexChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles cbxMode.SelectedIndexChanged
        If (sysService Is Nothing) Then
            Return
        End If
        Dim mode As Byte
        If (cbxMode.SelectedIndex = 0) Then
            mode = SysSvcApi.MODE_BAT
        Else
            mode = SysSvcApi.MODE_AC
        End If
        ReadPowerAndBacklightStatus(mode)
    End Sub


    Private Sub cbxKeypadStatus_SelectedIndexChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles cbxKeypadStatus.SelectedIndexChanged
        If (sysService Is Nothing) Then
            Return
        End If

        Select Case (cbxKeypadStatus.SelectedIndex)
            Case 0
                keypadStatus = KBD_STATUS.KBD_STATUS_LOWER_CASE
            Case 1
                keypadStatus = KBD_STATUS.KBD_STATUS_NUMERIC
            Case 2
                keypadStatus = KBD_STATUS.KBD_STATUS_UPPER_CASE
        End Select

        result = sysService.SetKBDStatus(keypadStatus)
        If (result <> SYSSVC_RESULT.SYSSVC_RESULT_SUCCESS) Then
            Utils.PlaySound("\Windows\Fail.wav")
            MessageBox.Show("SetKBDStatus : " + result.ToString())
        End If
    End Sub


    Private Sub nudTurnOffDevice_ValueChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles nudTurnOffDevice.ValueChanged
        If (sysService Is Nothing) Then
            Return
        End If
        Dim mode As Byte
        If (cbxMode.SelectedIndex = 0) Then
            mode = SysSvcApi.MODE_BAT
        Else
            mode = SysSvcApi.MODE_AC

        End If
        Dim nValue As UShort = CUShort(nudTurnOffDevice.Value)

        result = sysService.SuspendWriteTimeoutValue(mode, nValue)
        If (result <> SYSSVC_RESULT.SYSSVC_RESULT_SUCCESS) Then
            Utils.PlaySound("\Windows\Fail.wav")
            MessageBox.Show("SuspendWriteTimeoutValue : " + result.ToString())
        End If


    End Sub

    Private Sub nudTurnOffBacklight_ValueChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles nudTurnOffBacklight.ValueChanged
        If (sysService Is Nothing) Then
            Return
        End If
        Dim mode As Byte
        If (cbxMode.SelectedIndex = 0) Then
            mode = SysSvcApi.MODE_BAT
        Else
            mode = SysSvcApi.MODE_AC

        End If
        Dim nValue As UShort = CUShort(nudTurnOffBacklight.Value)

        result = sysService.BacklightWriteTimeoutValue(mode, nValue)
        If (result <> SYSSVC_RESULT.SYSSVC_RESULT_SUCCESS) Then
            Utils.PlaySound("\Windows\Fail.wav")
            MessageBox.Show("BacklightWriteTimeoutValue : " + result.ToString())
        End If

    End Sub

    Private Sub nudBacklightBrightness_ValueChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles nudBacklightBrightness.ValueChanged
        If (sysService Is Nothing) Then
            Return
        End If
        Dim mode As Byte
        If (cbxMode.SelectedIndex = 0) Then
            mode = SysSvcApi.MODE_BAT
        Else
            mode = SysSvcApi.MODE_AC

        End If
        Dim nValue As UShort = CUShort(nudBacklightBrightness.Value)

        result = sysService.BacklightWriteBrightness(mode, nValue)
        If (result <> SYSSVC_RESULT.SYSSVC_RESULT_SUCCESS) Then
            Utils.PlaySound("\Windows\Fail.wav")
            MessageBox.Show("BacklightBrightness : " + result.ToString())
        End If
    End Sub


    Private Sub btnSoftReset_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnSoftReset.Click
        If (sysService Is Nothing) Then
            Return
        End If

        sysService.SoftReset()
    End Sub

    Private Sub btnEnterSuspendState_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnEnterSuspendState.Click
        If (sysService Is Nothing) Then
            Return
        End If

        sysService.EnterSuspendState()
    End Sub


    Private Sub btnHWOptions_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnHWOptions.Click
        If (sysService Is Nothing) Then
            Return
        End If

        result = sysService.GetHardwareOptions(hwOptions)
        If (result <> SYSSVC_RESULT.SYSSVC_RESULT_SUCCESS) Then
            Utils.PlaySound("\Windows\Fail.wav")
            MessageBox.Show("GetHardwareOptions : " + result.ToString())
        Else
            Utils.PlaySound("\Windows\Success.wav")
            Dim msg As String = String.Empty

            If (hwOptions.Barcode = HW_TYPE_BARCODE.NONE) Then
                msg = msg + String.Format("Barcode : {0}{1}", "---", vbCrLf)
            Else
                msg = msg + String.Format("Barcode : {0}{1}", "Available", vbCrLf)
            End If

            If (hwOptions.Bluetooth = HW_TYPE_BLUETOOTH.NONE) Then
                msg = msg + String.Format("Bluetooth : {0}{1}", "---", vbCrLf)
            Else
                msg = msg + String.Format("Bluetooth : {0}{1}", "Available", vbCrLf)
            End If

            If (hwOptions.Camera = HW_TYPE_CAM.NONE) Then
                msg = msg + String.Format("Camera : {0}{1}", "---", vbCrLf)
            Else
                msg = msg + String.Format("Camera : {0}{1}", "Available", vbCrLf)
            End If

            If (hwOptions.FingerPrint = HW_TYPE_FINGERPRINT.NONE) Then
                msg = msg + String.Format("FingerPrint : {0}{1}", "---", vbCrLf)
            Else
                msg = msg + String.Format("FingerPrint : {0}{1}", "Available", vbCrLf)
            End If

            If (hwOptions.GPS = HW_TYPE_GPS.NONE) Then
                msg = msg + String.Format("GPS : {0}{1}", "---", vbCrLf)
            Else
                msg = msg + String.Format("GPS : {0}{1}", "Available", vbCrLf)
            End If

            If (hwOptions.HF = HW_TYPE_HF.NONE) Then
                msg = msg + String.Format("RFID HF : {0}{1}", "---", vbCrLf)
            Else
                msg = msg + String.Format("RFID HF : {0}{1}", "Available", vbCrLf)
            End If

            If (hwOptions.Modem = HW_TYPE_MODEM.NONE) Then
                msg = msg + String.Format("Modem : {0}{1}", "---", vbCrLf)
            Else
                msg = msg + String.Format("Modem : {0}{1}", "Available", vbCrLf)
            End If

            If (hwOptions.MSR = HW_TYPE_MSR.NONE) Then
                msg = msg + String.Format("MSR : {0}{1}", "---", vbCrLf)
            Else
                msg = msg + String.Format("MSR : {0}{1}", "Available", vbCrLf)
            End If

            If (hwOptions.Printer = HW_TYPE_PRINTER.NONE) Then
                msg = msg + String.Format("Printer : {0}{1}", "---", vbCrLf)
            Else
                msg = msg + String.Format("Printer : {0}{1}", "Available", vbCrLf)
            End If

            If (hwOptions.SmartCard = HW_TYPE_SMARTCARD.NONE) Then
                msg = msg + String.Format("SmartCard : {0}{1}", "---", vbCrLf)
            Else
                msg = msg + String.Format("SmartCard : {0}{1}", "Available", vbCrLf)
            End If

            If (hwOptions.UHF = HW_TYPE_UHF.NONE) Then
                msg = msg + String.Format("RFID UHF : {0}{1}", "---", vbCrLf)
            Else
                msg = msg + String.Format("RFID UHF : {0}{1}", "Available", vbCrLf)
            End If

            If (hwOptions.WLAN = HW_TYPE_WLAN.NONE) Then
                msg = msg + String.Format("WiFi : {0}{1}", "---", vbCrLf)
            Else
                msg = msg + String.Format("WiFi : {0}{1}", "Available", vbCrLf)
            End If
            MessageBox.Show(msg)
        End If
    End Sub
End Class
